#pragma once
#include "stdafx.h"
#include <list>
#include <iostream>
#include <sstream>
#include <string>
#include <stdio.h>
#include <windows.h>
#include <time.h>
#include "ThostFtdcTraderApi.h"
#include "ThostFtdcMdApi.h"
#include "DataCollect.h"
#include <conio.h>
#include "getconfig.h"
#include "traderApi.h"
#include "traderSpi.h"
#include "define.h"
#include <vector>
#include <map>
#include "time.h"

using namespace std;
FILE *logfile;

// ¼Ƿɵı־
// Create a manual reset event with no signal
HANDLE g_hEvent = CreateEvent(NULL, false, false, NULL);
/// Ա
TThostFtdcBrokerIDType g_chBrokerID;
/// û
TThostFtdcUserIDType g_chUserID;
/// û
TThostFtdcPasswordType g_chPassword;
/// 
TThostFtdcExchangeIDType g_chExchangeID;
///Լ
TThostFtdcInstrumentIDType	g_chInstrumentID;
///Ͷߴ
TThostFtdcInvestorIDType g_chInvestorID;
///Ԥ񳷵
TThostFtdcParkedOrderActionIDType	g_chParkedOrderActionID1;
///Ԥ񱨵
TThostFtdcParkedOrderIDType	g_chParkedOrderID1;
///
TThostFtdcOrderRefType	g_chOrderRef;
///ǰñ
TThostFtdcFrontIDType	g_chFrontID;
///Ự
TThostFtdcSessionIDType	g_chSessionID;
///
TThostFtdcOrderSysIDType	g_chOrderSysID;
///ֹ
TThostFtdcPriceType	g_chStopPrice;
///
TThostFtdcOrderRefType	g_chQuoteRef;
int FrontID = 0;
int SessionID = 0;
int Limitprice = 0;
int nRequestID = 0;
int chioce_action = 0;//Ϊ0ȫ
int OrderRef_num = 0;

vector<string> vector_OrderSysID;
vector<string> vector_ExchangeID;
vector<string> vector_InstrumentID;
vector<string> vector_OrderRef;
vector<int> vector_FrontID;
vector<int> vector_SessionID;
vector<string> md_InstrumentID;
int action_number;

///ִ
TThostFtdcOrderRefType	g_NewExecOrderRef;
///ִ
TThostFtdcExecOrderSysIDType	g_NewExecOrderSysID;
///ǰñ
TThostFtdcFrontIDType	g_NewFrontID;
///Ự
TThostFtdcSessionIDType	g_NewSessionID;

//ȨԶԳӦ֪ͨ
///ȨԶԳ
TThostFtdcOrderSysIDType	g_chOptionSelfCloseSysID;
///ȨԶԳ
TThostFtdcOrderRefType	g_chOptionSelfCloseRef;
///û˲ƷϢ
TThostFtdcProductInfoType	g_chUserProductInfo;
///֤
TThostFtdcAuthCodeType	g_chAuthCode;
///App
TThostFtdcAppIDType	g_chAppID;

HANDLE xinhao = CreateEvent(NULL, false, false, NULL);

CTraderApi *pUserApi = new CTraderApi;

//
class CSimpleMdHandler : public CThostFtdcMdSpi
{
public:
	// 캯ҪһЧָCThostFtdcMduserApiʵָ
	CSimpleMdHandler(CThostFtdcMdApi *pUserApi) : m_pUserMdApi(pUserApi) {}
	~CSimpleMdHandler() {}
	// ͻ뽻йϵͳͨӣͻҪе¼
	void deletemyself()
	{
		delete this;
	}

	virtual void OnFrontConnected()
	{
		strcpy_s(g_chBrokerID, getConfig("config", "BrokerID").c_str());
		strcpy_s(g_chUserID, getConfig("config", "UserID").c_str());
		strcpy_s(g_chPassword, getConfig("config", "Password").c_str());
		//SetEvent(xinhao);
		LOG("<OnFrontConnected>\n");
		LOG("</OnFrontConnected>\n");
		SetEvent(xinhao);
		//ReqUserLogin();
	}

	void RegisterFensUserInfo()
	{
		strcpy_s(g_chBrokerID, getConfig("config", "BrokerID").c_str());
		strcpy_s(g_chUserID, getConfig("config", "UserID").c_str());
		CThostFtdcFensUserInfoField pFens = { 0 };
		strcpy_s(pFens.BrokerID, g_chBrokerID);
		strcpy_s(pFens.UserID, g_chUserID);
		pFens.LoginMode = THOST_FTDC_LM_Trade;
		m_pUserMdApi->RegisterFensUserInfo(&pFens);
	}

	void ReqUserLogin()
	{
		CThostFtdcReqUserLoginField reqUserLogin = { 0 };
		strcpy_s(reqUserLogin.BrokerID, g_chBrokerID);
		//strcpy_s(reqUserLogin.UserID, g_chUserID);
		//strcpy_s(reqUserLogin.UserID, g_chPassword);
		int num = m_pUserMdApi->ReqUserLogin(&reqUserLogin, 2);
		LOG("\tlogin num = %d\n", num);
	}

	void ReqUserLogout()
	{
		CThostFtdcUserLogoutField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		int num = m_pUserMdApi->ReqUserLogout(&a, 1);
		LOG("\tlogout num = %d\n", num);
	}

	virtual void OnHeartBeatWarning(int nTimeLapse)
	{
		LOG("<OnHeartBeatWarning>\n");
		LOG("\tnTimeLapse [%d]\n", nTimeLapse);
		LOG("</OnHeartBeatWarning>\n");
	}

	// ͻ뽻йϵͳͨӶϿʱ÷
	virtual void OnFrontDisconnected(int nReason)
	{
		// APIԶӣͻ˿ɲ
		LOG("<OnFrontDisconnected>\n");
		LOG("\tnReason= = [%d]", nReason);
		LOG("</OnFrontDisconnected>\n");
	}

	// ͻ˷¼֮󣬸÷ᱻã֪ͨͻ˵¼Ƿɹ
	virtual void OnRspUserLogin(CThostFtdcRspUserLoginField *pRspUserLogin,
		CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspUserLogin>\n");
		if (pRspUserLogin)
		{
			LOG("\tTradingDay [%s]\n", pRspUserLogin->TradingDay);
			LOG("\tLoginTime [%s]\n", pRspUserLogin->LoginTime);
			LOG("\tBrokerID [%s]\n", pRspUserLogin->BrokerID);
			LOG("\tUserID [%s]\n", pRspUserLogin->UserID);
			LOG("\tSystemName [%s]\n", pRspUserLogin->SystemName);
			LOG("\tMaxOrderRef [%s]\n", pRspUserLogin->MaxOrderRef);
			LOG("\tSHFETime [%s]\n", pRspUserLogin->SHFETime);
			LOG("\tDCETime [%s]\n", pRspUserLogin->DCETime);
			LOG("\tCZCETime [%s]\n", pRspUserLogin->CZCETime);
			LOG("\tFFEXTime [%s]\n", pRspUserLogin->FFEXTime);
			LOG("\tINETime [%s]\n", pRspUserLogin->INETime);
			LOG("\tFrontID [%d]\n", pRspUserLogin->FrontID);
			LOG("\tSessionID [%d]\n", pRspUserLogin->SessionID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspUserLogin>\n");
		if (pRspInfo->ErrorID != 0) {
			// ˵ʧܣͻд
			LOG("\tFailed to login, errorcode=%d errormsg=%s requestid=%d chain = %d",
				pRspInfo->ErrorID, pRspInfo->ErrorMsg, nRequestID, bIsLast);
			cin.get();
			cin.ignore();
			exit(-1);
		}
		SetEvent(xinhao);
	}

	///ǳӦ
	virtual void OnRspUserLogout(CThostFtdcUserLogoutField* pUserLogout, CThostFtdcRspInfoField* pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspUserLogout>\n");
		if (pUserLogout)
		{
			LOG("\tBrokerID [%s]\n", pUserLogout->BrokerID);
			LOG("\tUserID [%s]\n", pUserLogout->UserID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspUserLogout>\n");
		SetEvent(xinhao);
		//pUserApi->Release();
	}

	void UnSubscribeMarketData()
	{
		int md_num = 0;
		char **ppInstrumentID = new char*[5000];
		for (int count1 = 0; count1 <= md_InstrumentID.size() / 500; count1++)
		{
			if (count1 < md_InstrumentID.size() / 500)
			{
				int a = 0;
				for (a; a < 500; a++)
				{
					ppInstrumentID[a] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->UnSubscribeMarketData(ppInstrumentID, a);
				LOG((result == 0) ? "˶1......ͳɹ\n" : "˶1......ʧܣ=[%d]\n", result);
			}
			else if (count1 == md_InstrumentID.size() / 500)
			{
				int count2 = 0;
				for (count2; count2 < md_InstrumentID.size() % 500; count2++)
				{
					ppInstrumentID[count2] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->UnSubscribeMarketData(ppInstrumentID, count2);
				LOG((result == 0) ? "˶2......ͳɹ\n" : "˶2......ʧܣ=[%d]\n", result);
			}
		}
	}

	virtual void OnRspUnSubMarketData(CThostFtdcSpecificInstrumentField *pSpecificInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspUnSubMarketData>\n");
		if (pSpecificInstrument)
		{
			LOG("\tInstrumentID [%s]\n", pSpecificInstrument->InstrumentID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspUnSubMarketData>\n");
		if (bIsLast)
		{
			SetEvent(xinhao);
		}
	};

	void SubscribeMarketData()//
	{
		int md_num = 0;
		char **ppInstrumentID = new char*[5000];
		for (int count1 = 0; count1 <= md_InstrumentID.size() / 500; count1++)
		{
			if (count1 < md_InstrumentID.size() / 500)
			{
				int a = 0;
				for (a; a < 500; a++)
				{
					ppInstrumentID[a] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->SubscribeMarketData(ppInstrumentID, a);
				LOG((result == 0) ? "1......ͳɹ\n" : "1......ʧܣ=[%d]\n", result);
			}
			else if (count1 == md_InstrumentID.size() / 500)
			{
				int count2 = 0;
				for (count2; count2 < md_InstrumentID.size() % 500; count2++)
				{
					ppInstrumentID[count2] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->SubscribeMarketData(ppInstrumentID, count2);
				LOG((result == 0) ? "2......ͳɹ\n" : "2......ʧܣ=[%d]\n", result);
			}
		}
	}

	virtual void OnRspSubMarketData(CThostFtdcSpecificInstrumentField *pSpecificInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspSubMarketData>\n");
		if (pSpecificInstrument)
		{
			LOG("\tInstrumentID [%s]\n", pSpecificInstrument->InstrumentID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspSubMarketData>\n");
		if (bIsLast)
		{
			SetEvent(xinhao);
		}
	};

	///֪ͨ
	virtual void OnRtnDepthMarketData(CThostFtdcDepthMarketDataField *pDepthMarketData)
	{
		//ȡϵͳʱ
		SYSTEMTIME sys;
		GetLocalTime(&sys);
		LOG("%02d:%02d:%02d.%03d\t",
			sys.wHour,
			sys.wMinute,
			sys.wSecond,
			sys.wMilliseconds);
		LOG("<OnRtnDepthMarketData>");
		if (pDepthMarketData)
		{
			LOG("\tTradingDay [%s]\n", pDepthMarketData->TradingDay);
			LOG("\tInstrumentID [%s]", pDepthMarketData->InstrumentID);
			LOG("\tExchangeID [%s]", pDepthMarketData->ExchangeID);
			LOG("\tExchangeInstID [%s]\n", pDepthMarketData->ExchangeInstID);
			LOG("\tUpdateTime [%s]", pDepthMarketData->UpdateTime);
			LOG("\tActionDay [%s]\n", pDepthMarketData->ActionDay);
			LOG("\tVolume [%d]\n", pDepthMarketData->Volume);
			LOG("\tUpdateMillisec [%d]", pDepthMarketData->UpdateMillisec);
			LOG("\tBidVolume1 [%d]\n", pDepthMarketData->BidVolume1);
			LOG("\tAskVolume1 [%d]\n", pDepthMarketData->AskVolume1);
			LOG("\tBidVolume2 [%d]\n", pDepthMarketData->BidVolume2);
			LOG("\tAskVolume2 [%d]\n", pDepthMarketData->AskVolume2);
			LOG("\tBidVolume3 [%d]\n", pDepthMarketData->BidVolume3);
			LOG("\tAskVolume3 [%d]\n", pDepthMarketData->AskVolume3);
			LOG("\tBidVolume4 [%d]\n", pDepthMarketData->BidVolume4);
			LOG("\tAskVolume4 [%d]\n", pDepthMarketData->AskVolume4);
			LOG("\tBidVolume5 [%d]\n", pDepthMarketData->BidVolume5);
			LOG("\tAskVolume5 [%d]\n", pDepthMarketData->AskVolume5);
			LOG("\tLastPrice [%.8lf]\n", (pDepthMarketData->LastPrice > 10000000) ? 0 : pDepthMarketData->LastPrice);
			LOG("\tPreSettlementPrice [%.8lf]\n", (pDepthMarketData->PreSettlementPrice > 10000000) ? 0 : pDepthMarketData->PreSettlementPrice);
			LOG("\tPreClosePrice [%.8lf]\n", (pDepthMarketData->PreClosePrice > 10000000) ? 0 : pDepthMarketData->PreClosePrice);
			LOG("\tPreOpenInterest [%.8lf]\n", (pDepthMarketData->PreOpenInterest > 10000000) ? 0 : pDepthMarketData->PreOpenInterest);
			LOG("\tOpenPrice [%.8lf]\n", (pDepthMarketData->OpenPrice > 10000000) ? 0 : pDepthMarketData->OpenPrice);
			LOG("\tHighestPrice [%.8lf]\n", (pDepthMarketData->HighestPrice > 10000000) ? 0 : pDepthMarketData->HighestPrice);
			LOG("\tLowestPrice [%.8lf]\n", (pDepthMarketData->LowestPrice > 10000000) ? 0 : pDepthMarketData->LowestPrice);
			LOG("\tTurnover [%.8lf]\n", (pDepthMarketData->Turnover > 10000000) ? 0 : pDepthMarketData->Turnover);
			LOG("\tOpenInterest [%.8lf]\n", (pDepthMarketData->OpenInterest > 10000000) ? 0 : pDepthMarketData->OpenInterest);
			LOG("\tClosePrice [%.8lf]\n", (pDepthMarketData->ClosePrice > 10000000) ? 0 : pDepthMarketData->ClosePrice);
			LOG("\tSettlementPrice [%.8lf]\n", (pDepthMarketData->SettlementPrice > 10000000) ? 0 : pDepthMarketData->SettlementPrice);
			LOG("\tUpperLimitPrice [%.8lf]\n", (pDepthMarketData->UpperLimitPrice > 10000000) ? 0 : pDepthMarketData->UpperLimitPrice);
			LOG("\tLowerLimitPrice [%.8lf]\n", (pDepthMarketData->LowerLimitPrice > 10000000) ? 0 : pDepthMarketData->LowerLimitPrice);
			LOG("\tPreDelta [%.8lf]\n", (pDepthMarketData->PreDelta > 10000000) ? 0 : pDepthMarketData->PreDelta);
			LOG("\tCurrDelta [%.8lf]\n", (pDepthMarketData->CurrDelta > 10000000) ? 0 : pDepthMarketData->CurrDelta);
			LOG("\tBidPrice1 [%.8lf]\n", (pDepthMarketData->BidPrice1 > 10000000) ? 0 : pDepthMarketData->BidPrice1);
			LOG("\tAskPrice1 [%.8lf]\n", (pDepthMarketData->AskPrice1 > 10000000) ? 0 : pDepthMarketData->AskPrice1);
			LOG("\tBidPrice2 [%.8lf]\n", (pDepthMarketData->BidPrice2 > 10000000) ? 0 : pDepthMarketData->BidPrice2);
			LOG("\tAskPrice2 [%.8lf]\n", (pDepthMarketData->AskPrice2 > 10000000) ? 0 : pDepthMarketData->AskPrice2);
			LOG("\tBidPrice3 [%.8lf]\n", (pDepthMarketData->BidPrice3 > 10000000) ? 0 : pDepthMarketData->BidPrice3);
			LOG("\tAskPrice3 [%.8lf]\n", (pDepthMarketData->AskPrice3 > 10000000) ? 0 : pDepthMarketData->AskPrice3);
			LOG("\tBidPrice4 [%.8lf]\n", (pDepthMarketData->BidPrice4 > 10000000) ? 0 : pDepthMarketData->BidPrice4);
			LOG("\tAskPrice4 [%.8lf]\n", (pDepthMarketData->AskPrice4 > 10000000) ? 0 : pDepthMarketData->AskPrice4);
			LOG("\tBidPrice5 [%.8lf]\n", (pDepthMarketData->BidPrice5 > 10000000) ? 0 : pDepthMarketData->BidPrice5);
			LOG("\tAskPrice5 [%.8lf]\n", (pDepthMarketData->AskPrice5 > 10000000) ? 0 : pDepthMarketData->AskPrice5);
			LOG("\tAveragePrice [%.8lf]\n", (pDepthMarketData->AveragePrice > 10000000) ? 0 : pDepthMarketData->AveragePrice);
		}
		LOG("</OnRtnDepthMarketData>\n");
	};

	///ѯ
	void SubscribeForQuoteRsp()
	{
		int md_num = 0;
		char **ppInstrumentID = new char*[5000];
		for (int count1 = 0; count1 <= md_InstrumentID.size() / 500; count1++)
		{
			if (count1 < md_InstrumentID.size() / 500)
			{
				int a = 0;
				for (a; a < 500; a++)
				{
					ppInstrumentID[a] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->SubscribeForQuoteRsp(ppInstrumentID, a);
				LOG((result == 0) ? "ѯ1......ͳɹ\n" : "ѯ1......ʧܣ=[%d]\n", result);
			}
			else if (count1 == md_InstrumentID.size() / 500)
			{
				int count2 = 0;
				for (count2; count2 < md_InstrumentID.size() % 500; count2++)
				{
					ppInstrumentID[count2] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->SubscribeForQuoteRsp(ppInstrumentID, count2);
				LOG((result == 0) ? "ѯ2......ͳɹ\n" : "ѯ2......ʧܣ=[%d]\n", result);
			}
		}
	}

	virtual void OnRspSubForQuoteRsp(CThostFtdcSpecificInstrumentField *pSpecificInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspSubForQuoteRsp>\n");
		if (pSpecificInstrument)
		{
			LOG("\tInstrumentID [%s]\n", pSpecificInstrument->InstrumentID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspSubForQuoteRsp>\n");
		if (bIsLast)
		{
			SetEvent(xinhao);
		}
	};

	void UnSubscribeForQuoteRsp()
	{
		int md_num = 0;
		char **ppInstrumentID = new char*[5000];
		for (int count1 = 0; count1 <= md_InstrumentID.size() / 500; count1++)
		{
			if (count1 < md_InstrumentID.size() / 500)
			{
				int a = 0;
				for (a; a < 500; a++)
				{
					ppInstrumentID[a] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->UnSubscribeForQuoteRsp(ppInstrumentID, a);
				LOG((result == 0) ? "˶ѯ1......ͳɹ\n" : "˶ѯ1......ʧܣ=[%d]\n", result);
			}
			else if (count1 == md_InstrumentID.size() / 500)
			{
				int count2 = 0;
				for (count2; count2 < md_InstrumentID.size() % 500; count2++)
				{
					ppInstrumentID[count2] = const_cast<char *>(md_InstrumentID.at(md_num).c_str());
					md_num++;
				}
				int result = m_pUserMdApi->UnSubscribeForQuoteRsp(ppInstrumentID, count2);
				LOG((result == 0) ? "˶ѯ2......ͳɹ\n" : "˶ѯ2......ʧܣ=[%d]\n", result);
			}
		}
	}

	virtual void OnRspUnSubForQuoteRsp(CThostFtdcSpecificInstrumentField *pSpecificInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspUnSubForQuoteRsp>\n");
		if (pSpecificInstrument)
		{
			LOG("\tInstrumentID [%s]\n", pSpecificInstrument->InstrumentID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspUnSubForQuoteRsp>\n");
		if (bIsLast)
		{
			SetEvent(xinhao);
		}
	};

	///ѯ֪ͨ
	virtual void OnRtnForQuoteRsp(CThostFtdcForQuoteRspField *pForQuoteRsp)
	{
		LOG("<OnRtnForQuoteRsp>\n");
		if (pForQuoteRsp)
		{
			LOG("\tTradingDay [%s]\n", pForQuoteRsp->TradingDay);
			LOG("\tInstrumentID [%s]\n", pForQuoteRsp->InstrumentID);
			LOG("\tForQuoteSysID [%s]\n", pForQuoteRsp->ForQuoteSysID);
			LOG("\tForQuoteTime [%s]\n", pForQuoteRsp->ForQuoteTime);
			LOG("\tActionDay [%s]\n", pForQuoteRsp->ActionDay);
			LOG("\tExchangeID [%s]\n", pForQuoteRsp->ExchangeID);
		}
		LOG("</OnRtnForQuoteRsp>\n");
	}

	void ReqQryMulticastInstrument()
	{
		string new_TopicID;
		LOG("TopicIDֵ:\n");
		cin >> new_TopicID;

		CThostFtdcQryMulticastInstrumentField a = { 0 };
		a.TopicID = atoi(new_TopicID.c_str());
		//strcpy_s(a.InstrumentID, "");
		int b = m_pUserMdApi->ReqQryMulticastInstrument(&a, nRequestID++);
		LOG((b == 0) ? "ѯ鲥Լ......ͳɹ\n" : "ѯ鲥Լ......ʧܣ=[%d]\n", b);
	}

	virtual void OnRspQryMulticastInstrument(CThostFtdcMulticastInstrumentField *pMulticastInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspQryMulticastInstrument>\n");
		if (pMulticastInstrument)
		{
			LOG("\tInstrumentID [%s]\n", pMulticastInstrument->InstrumentID);
			LOG("\tTopicID [%d]\n", pMulticastInstrument->TopicID);
			LOG("\tInstrumentNo [%d]\n", pMulticastInstrument->InstrumentNo);
			LOG("\tVolumeMultiple [%d]\n", pMulticastInstrument->VolumeMultiple);
			LOG("\tCodePrice [%.8lf]\n", (pMulticastInstrument->CodePrice > 10000000) ? 0 : pMulticastInstrument->CodePrice);
			LOG("\tPriceTick [%.8lf]\n", (pMulticastInstrument->PriceTick > 10000000) ? 0 : pMulticastInstrument->PriceTick);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspQryMulticastInstrument>\n");
	};

private:
	// ָCThostFtdcMduserApiʵָ
	CThostFtdcMdApi *m_pUserMdApi;
};

//
class CSimpleHandler : public CTraderSpi
{
public:
	CSimpleHandler(CThostFtdcTraderApi *pUserApi) :
		m_pUserApi(pUserApi) {}
	~CSimpleHandler() {}
	virtual void OnFrontConnected()
	{
		printf("ThreadID: %d\n", GetCurrentThreadId()); //ٶȸ
		LOG("<OnFrontConnected>\n");
		LOG("</OnFrontConnected>\n");
		strcpy_s(g_chBrokerID, getConfig("config", "BrokerID").c_str());
		strcpy_s(g_chUserID, getConfig("config", "UserID").c_str());
		strcpy_s(g_chPassword, getConfig("config", "Password").c_str());
		strcpy_s(g_chInvestorID, getConfig("config", "InvestorID").c_str());
		strcpy_s(g_chAuthCode, getConfig("config", "AuthCode").c_str());
		strcpy_s(g_chAppID, getConfig("config", "AppID").c_str());
		strcpy_s(g_chInstrumentID, getConfig("config", "InstrumentID").c_str());
		strcpy_s(g_chExchangeID, getConfig("config", "ExchangeID").c_str());

		strcpy_s(g_NewExecOrderRef, "");
		strcpy_s(g_NewExecOrderSysID, "");
		g_NewFrontID = 0;
		g_NewSessionID = 0;
		SetEvent(g_hEvent);
	}

	//ѯǩԼϵ
	void ReqQryAccountregister()
	{
		CThostFtdcQryAccountregisterField a = { 0 };
		//strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.AccountID, g_chInvestorID);
		//strcpy_s(a.BankID, "3");
		//strcpy_s(a.BankBranchID, "0740");
		//strcpy_s(a.CurrencyID, "CNY");
		int b = m_pUserApi->ReqQryAccountregister(&a, nRequestID++);
		LOG((b == 0) ? "ѯǩԼϵ......ͳɹ\n" : "ѯǩԼϵ......ʧܣ=[%d]\n", b);
	}

	//ѯǩԼ
	void ReqQryContractBank()
	{
		CThostFtdcQryContractBankField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.BankID, "");
		int b = m_pUserApi->ReqQryContractBank(&a, nRequestID++);
		LOG((b == 0) ? "ѯǩԼϵ......ͳɹ\n" : "ѯǩԼϵ......ʧܣ=[%d]\n", b);
	}

	void ReqQryDepthMarketData()
	{
		CThostFtdcQryDepthMarketDataField a = { 0 };
		//strcpy_s(a.ExchangeID, "SHFE");
		//strcpy_s(a.BankID, g_chBrokerID);
		int b = m_pUserApi->ReqQryDepthMarketData(&a, nRequestID++);
		LOG((b == 0) ? "ѯ......ͳɹ\n" : "ѯ......ʧܣ=[%d]\n", b);
	}

	//ѯ͹˾㷨
	void ReqQryBrokerTradingAlgos()
	{
		CThostFtdcQryBrokerTradingAlgosField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.ExchangeID, g_chExchangeID);
		//strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryBrokerTradingAlgos(&a, nRequestID++);
		LOG((b == 0) ? "ѯ͹˾㷨......ͳɹ\n" : "ѯ͹˾㷨......ʧܣ=[%d]\n", b);
	}

	//ѯ֤ϵͳ͹˾ʽ˻Կ
	void ReqQryCFMMCTradingAccountKey()
	{
		CThostFtdcQryCFMMCTradingAccountKeyField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chUserID);
		int b = m_pUserApi->ReqQryCFMMCTradingAccountKey(&a, nRequestID++);
		LOG((b == 0) ? "ѯ֤ϵͳ͹˾ʽ˻Կ......ͳɹ\n" : "ѯ֤ϵͳ͹˾ʽ˻Կ......ʧܣ=[%d]\n", b);
	}

	//ͻ֤
	void ReqAuthenticate()
	{
		strcpy_s(g_chAuthCode, getConfig("config", "AuthCode").c_str());
		strcpy_s(g_chAppID, getConfig("config", "AppID").c_str());

		CThostFtdcReqAuthenticateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.AuthCode, g_chAuthCode);
		strcpy_s(a.AppID, g_chAppID);
		//strcpy_s(a.UserProductInfo, g_chAppID);
		int b = m_pUserApi->ReqAuthenticate(&a, nRequestID++);
		printf("\tͻ֤ = [%d]\n", b);
	}

	///ͻ֤Ӧ
	virtual void OnRspAuthenticate(CThostFtdcRspAuthenticateField *pRspAuthenticateField, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspAuthenticate(pRspAuthenticateField, pRspInfo, nRequestID, bIsLast);
		SetEvent(g_hEvent);
	}

	void RegisterFensUserInfo()
	{
		CThostFtdcFensUserInfoField pFensUserInfo = { 0 };
		strcpy_s(pFensUserInfo.BrokerID, getConfig("config", "BrokerID").c_str());
		strcpy_s(pFensUserInfo.UserID, getConfig("config", "UserID").c_str());
		pFensUserInfo.LoginMode = THOST_FTDC_LM_Trade;
		m_pUserApi->RegisterFensUserInfo(&pFensUserInfo);
	}

	virtual void OnFrontDisconnected(int nReason)
	{
		LOG("<OnFrontDisconnected>\n");
		LOG("\tnReason = %d\n", nReason);
		LOG("</OnFrontDisconnected>\n");
	}

	void ReqUserLogin()
	{
		CThostFtdcReqUserLoginField reqUserLogin = { 0 };
		strcpy_s(reqUserLogin.BrokerID, g_chBrokerID);
		strcpy_s(reqUserLogin.UserID, g_chUserID);
		strcpy_s(reqUserLogin.Password, g_chPassword);
		//strcpy_s(reqUserLogin.ClientIPAddress, "::c0a8:0101");
		strcpy_s(reqUserLogin.LoginRemark, "test");
		// ½
		m_pUserApi->ReqUserLogin(&reqUserLogin, nRequestID++);
	}

	virtual void OnRspUserLogin(CThostFtdcRspUserLoginField *pRspUserLogin,
		CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		//pUserApi->Release();
		FrontID = pRspUserLogin->FrontID;
		SessionID = pRspUserLogin->SessionID;
		CTraderSpi::OnRspUserLogin(pRspUserLogin, pRspInfo, nRequestID, bIsLast);
		
		if (pRspInfo->ErrorID != 0)
		//if (pRspInfo)
		{
			LOG("\tFailed to login, errorcode=[%d]\n \terrormsg=[%s]\n \trequestid = [%d]\n \tchain = [%d]\n",
				pRspInfo->ErrorID, pRspInfo->ErrorMsg, nRequestID, bIsLast);
			//exit(-1);
		}
		SetEvent(g_hEvent);
	}

	void ReqUserLogout()
	{
		CThostFtdcUserLogoutField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		m_pUserApi->ReqUserLogout(&a, nRequestID++);
	}

	///ǳӦ
	virtual void OnRspUserLogout(CThostFtdcUserLogoutField *pUserLogout, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		LOG("<OnRspUserLogout>\n");
		if (pUserLogout)
		{
			LOG("\tBrokerID [%s]\n", pUserLogout->BrokerID);
			LOG("\tUserID [%s]\n", pUserLogout->UserID);
		}
		if (pRspInfo)
		{
			LOG("\tErrorMsg [%s]\n", pRspInfo->ErrorMsg);
			LOG("\tErrorID [%d]\n", pRspInfo->ErrorID);
		}
		LOG("\tnRequestID [%d]\n", nRequestID);
		LOG("\tbIsLast [%d]\n", bIsLast);
		LOG("</OnRspUserLogout>\n");
		SetEvent(g_hEvent);
	}

	///ȷϽ㵥
	void ReqSettlementInfoConfirm()
	{
		CThostFtdcSettlementInfoConfirmField Confirm = { 0 };
		///͹˾
		strcpy_s(Confirm.BrokerID, g_chBrokerID);
		///Ͷߴ
		strcpy_s(Confirm.InvestorID, g_chInvestorID);
		int b = m_pUserApi->ReqSettlementInfoConfirm(&Confirm, nRequestID++);
		LOG((b == 0) ? "ȷϽ㵥......ͳɹ\n" : "ȷϽ㵥......ʧܣ=[%d]\n", b);
	}

	///Ͷ߽ȷӦ
	virtual void OnRspSettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm,
		CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspSettlementInfoConfirm(pSettlementInfoConfirm, pRspInfo, nRequestID, bIsLast);
		SetEvent(g_hEvent);
	}

	///û
	void ReqUserPasswordUpdate()
	{
		string newpassword;
		LOG("µ¼룺\n");
		cin >> newpassword;
		CThostFtdcUserPasswordUpdateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.OldPassword, g_chPassword);
		strcpy_s(a.NewPassword, newpassword.c_str());
		int b = m_pUserApi->ReqUserPasswordUpdate(&a, nRequestID++);
		LOG((b == 0) ? "û......ͳɹ\n" : "û......ʧܣ=[%d]\n", b);
	}

	///ûӦ
	virtual void OnRspUserPasswordUpdate(CThostFtdcUserPasswordUpdateField *pUserPasswordUpdate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspUserPasswordUpdate(pUserPasswordUpdate, pRspInfo, nRequestID, bIsLast);
		SetEvent(g_hEvent);
	}

	///ʽ˻
	void ReqTradingAccountPasswordUpdate()
	{
		string newpassword;
		LOG("ʽ룺\n");
		cin >> newpassword;
		CThostFtdcTradingAccountPasswordUpdateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.AccountID, g_chInvestorID);
		strcpy_s(a.OldPassword, g_chPassword);
		strcpy_s(a.NewPassword, newpassword.c_str());
		strcpy_s(a.CurrencyID, "CNY");
		int b = m_pUserApi->ReqTradingAccountPasswordUpdate(&a, nRequestID++);
		LOG((b == 0) ? "ʽ˻......ͳɹ\n" : "ʽ˻......ʧܣ=[%d]\n", b);
	}

	///ʽ˻Ӧ
	virtual void OnRspTradingAccountPasswordUpdate(CThostFtdcTradingAccountPasswordUpdateField *pTradingAccountPasswordUpdate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspTradingAccountPasswordUpdate(pTradingAccountPasswordUpdate, pRspInfo, nRequestID, bIsLast);
		SetEvent(g_hEvent);
	}

	///Ԥ¼//޼۵
	void ReqParkedOrderInsert()
	{
		int limitprice = 0;
		LOG("޼۵۸(Ĭ0)\n");
		cin >> limitprice;
		CThostFtdcParkedOrderField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, a.OrderRef, 10);
		a.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		a.Direction = THOST_FTDC_D_Buy;
		a.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		a.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		a.LimitPrice = limitprice;
		a.VolumeTotalOriginal = 1;
		a.TimeCondition = THOST_FTDC_TC_GFD;
		a.VolumeCondition = THOST_FTDC_VC_AV;
		a.MinVolume = 1;
		a.ContingentCondition = THOST_FTDC_CC_Immediately;
		a.StopPrice = 0;
		a.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		a.IsAutoSuspend = 0;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int b = m_pUserApi->ReqParkedOrderInsert(&a, nRequestID++);
		LOG((b == 0) ? "¼Ԥ......ͳɹ\n" : "¼Ԥ......ʧܣ=[%d]\n", b);
	}

	///Ԥ񳷵¼
	void ReqParkedOrderAction()
	{
		CThostFtdcParkedOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.OrderRef, "          15");
		strcpy_s(a.ExchangeID, g_chExchangeID);
		/*a.FrontID = 1;
		a.SessionID = -287506422;*/
		strcpy_s(a.OrderSysID, g_chOrderSysID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		a.ActionFlag = THOST_FTDC_AF_Delete;
		int b = m_pUserApi->ReqParkedOrderAction(&a, nRequestID++);
		LOG((b == 0) ? "¼Ԥ񳷵......ͳɹ\n" : "¼Ԥ񳷵......ʧܣ=[%d]\n", b);
	}

	///ɾԤ
	void ReqRemoveParkedOrder()
	{
		CThostFtdcRemoveParkedOrderField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.ParkedOrderID, g_chParkedOrderID1);
		int b = m_pUserApi->ReqRemoveParkedOrder(&a, nRequestID++);
		LOG((b == 0) ? "ɾԤ......ͳɹ\n" : "ɾԤ......ʧܣ=[%d]\n", b);
	}

	///ɾԤ񳷵
	void ReqRemoveParkedOrderAction()
	{
		CThostFtdcRemoveParkedOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.ParkedOrderActionID, g_chParkedOrderActionID1);
		int b = m_pUserApi->ReqRemoveParkedOrderAction(&a, nRequestID++);
		LOG((b == 0) ? "ɾԤ񳷵......ͳɹ\n" : "ɾԤ񳷵......ʧܣ=[%d]\n", b);
	}

	///мֹ
	void ReqOrderInsert_dce()
	{
		system("cls");
		string new_limitprice;
		LOG("ֹӯ۸\n");
		cin >> new_limitprice;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef,"");
		//strcpy_s(ord.OrderRef, itoa(OrderRef_num));
		ord.OrderPriceType = THOST_FTDC_OPT_AnyPrice;
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;

		int num1;
	Direction:LOG("ѡ\t1.\t2.\n");
		cin >> num1;
		if (num1 == 1) {
			ord.Direction = THOST_FTDC_D_Buy;//
		}
		else if (num1 == 2) {
			ord.Direction = THOST_FTDC_D_Sell;//
		}
		else {
			LOG("\n");
			_getch();
			goto Direction;
		}
		int num2;
	CombOffsetFlag:LOG("뿪ƽ\t1.\t2.ƽ\t3.ǿƽ\t4.ƽ\t5.ƽ\t6.ǿ\t7.ǿƽ\n");
		cin >> num2;
		if (num2 == 1) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		}
		else if (num2 == 2) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_Close;
		}
		else if (num2 == 3) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_ForceClose;
		}
		else if (num2 == 4) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_CloseToday;
		}
		else if (num2 == 5) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_CloseYesterday;
		}
		else if (num2 == 6) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_ForceOff;
		}
		else if (num2 == 7) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_LocalForceClose;
		}
		else {
			LOG("\n");
			_getch();
			goto CombOffsetFlag;
		}
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = 0;
		//ord.LimitPrice = 598;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 0;
		ord.ContingentCondition = THOST_FTDC_CC_Touch;
		ord.StopPrice = atoi(new_limitprice.c_str());
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 1;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}


	///¼
	void ReqOrderInsert_Ordinary()
	{
		system("cls");
		string new_limitprice;
		LOG("ָ۸\n");
		cin >> new_limitprice;

		CThostFtdcInputOrderField ord = { 0 };
		ord.RequestID = 1234;
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef,10);
		//strcpy_s(ord.OrderRef,"");
		//strcpy_s(ord.OrderRef, itoa(OrderRef_num));
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		
		int num1;
	Direction:LOG("ѡ\t1.\t2.\n");
		cin >> num1;
		if(num1==1){
			ord.Direction = THOST_FTDC_D_Buy;//
		}
		else if (num1 == 2) {
			ord.Direction = THOST_FTDC_D_Sell;//
		}
		else {
			LOG("\n");
			_getch();
			goto Direction;
		}
		int num2;
	CombOffsetFlag:LOG("뿪ƽ\t1.\t2.ƽ\t3.ǿƽ\t4.ƽ\t5.ƽ\t6.ǿ\t7.ǿƽ\n");
		cin >> num2;
		if (num2 == 1) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		}
		else if (num2 == 2) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_Close;
		}
		else if (num2 == 3) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_ForceClose;
		}
		else if (num2 == 4) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_CloseToday;
		}
		else if (num2 == 5) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_CloseYesterday;
		}
		else if (num2 == 6) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_ForceOff;
		}
		else if (num2 == 7) {
			ord.CombOffsetFlag[0] = THOST_FTDC_OF_LocalForceClose;
		}
		else {
			LOG("\n");
			_getch();
			goto CombOffsetFlag;
		}
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(new_limitprice.c_str());
		//ord.LimitPrice = 598;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_LackDeposit;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	///ֹ
	void ReqOrderInsert_Touch()
	{
		int new_limitprice;
		LOG("ָ۸limitprice\n");
		cin >> new_limitprice;

		int new_StopPrice;
		LOG("ָ۸stopprice\n");
		cin >> new_StopPrice;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Touch;
		ord.StopPrice = new_StopPrice;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	///ֹӯ
	void ReqOrderInsert_TouchProfit()
	{
		int new_limitprice;
		LOG("ָ۸limitprice\n");
		cin >> new_limitprice;

		int new_StopPrice;
		LOG("ָ۸stopprice\n");
		cin >> new_StopPrice;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///ȫ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_TouchProfit;
		ord.StopPrice = new_StopPrice;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//ȫȫ FOK
	void ReqOrderInsert_VC_CV()
	{
		int new_limitprice;
		LOG("ָ۸\n");
		cin >> new_limitprice;

		int insert_num;
		LOG("µ\n");
		cin >> insert_num;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = insert_num;
		ord.TimeCondition = THOST_FTDC_TC_IOC;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_CV;///ȫ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//ɲ FAK
	void ReqOrderInsert_VC_AV()
	{
		int new_limitprice;
		LOG("ָ۸\n");
		cin >> new_limitprice;

		int insert_num;
		LOG("µ\n");
		cin >> insert_num;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = insert_num;
		ord.TimeCondition = THOST_FTDC_TC_IOC;///ɣ
		ord.VolumeCondition = THOST_FTDC_VC_MV;///κ
		ord.MinVolume = 2;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//м۵
	void ReqOrderInsert_AnyPrice()
	{
		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_AnyPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		//ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.LimitPrice = 0;//۸
		ord.VolumeTotalOriginal = 40;
		ord.TimeCondition = THOST_FTDC_TC_IOC;///ɣ
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;//
		//ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;//ǿƽ
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//мת޼۵(н)
	void ReqOrderInsert_BestPrice()
	{
		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_BestPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		//ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//ָ
	void ReqOrderInsert_Arbitrage()
	{
		int new_limitprice;
		LOG("ָ۸\n");
		cin >> new_limitprice;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	//
	void ReqOrderInsert_IsSwapOrder()
	{
		int new_limitprice;
		LOG("ָ۸\n");
		cin >> new_limitprice;

		CThostFtdcInputOrderField ord = { 0 };
		strcpy_s(ord.BrokerID, g_chBrokerID);
		strcpy_s(ord.InvestorID, g_chInvestorID);
		strcpy_s(ord.InstrumentID, g_chInstrumentID);
		strcpy_s(ord.UserID, g_chUserID);
		OrderRef_num++;
		itoa(OrderRef_num, ord.OrderRef, 10);
		//strcpy_s(ord.OrderRef, "");
		ord.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		ord.Direction = THOST_FTDC_D_Buy;//
		ord.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		ord.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		ord.LimitPrice = atoi(getConfig("config", "LimitPrice").c_str());
		//ord.LimitPrice = new_limitprice;
		ord.VolumeTotalOriginal = 1;
		ord.TimeCondition = THOST_FTDC_TC_GFD;///Ч
		ord.VolumeCondition = THOST_FTDC_VC_AV;///κ
		ord.MinVolume = 1;
		ord.ContingentCondition = THOST_FTDC_CC_Immediately;
		ord.StopPrice = 0;
		ord.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		ord.IsAutoSuspend = 0;
		ord.IsSwapOrder = 1;//־
		strcpy_s(ord.ExchangeID, g_chExchangeID);
		int a = m_pUserApi->ReqOrderInsert(&ord, 1);
		LOG((a == 0) ? "¼޼۵......ͳɹ\n" : "¼޼۵......ʧܣ=[%d]\n", a);
	}

	///¼
	void ReqCombActionInsert()
	{
		CThostFtdcInputCombActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		//strcpy_s(a.CombActionRef,"");//
		a.Direction = THOST_FTDC_D_Sell;//
		a.Volume = 1;
		a.CombDirection = THOST_FTDC_CMDR_Comb;
		a.HedgeFlag = THOST_FTDC_HF_Speculation;//Ͷ
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int ab = m_pUserApi->ReqCombActionInsert(&a, nRequestID++);
		LOG((ab == 0) ? "¼......ͳɹ\n" : "¼......ʧܣ=[%d]\n", ab);
	}

	///
	void ReqOrderAction_Ordinary()
	{
		CThostFtdcInputOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		a.OrderActionRef = 1;
		strcpy_s(a.OrderRef, g_chOrderRef);
		//a.FrontID = g_chFrontID;
		//a.SessionID = g_chSessionID;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.OrderSysID, g_chOrderSysID);
		a.ActionFlag = THOST_FTDC_AF_Delete;
		strcpy_s(a.UserID, g_chUserID);
		int ab = m_pUserApi->ReqOrderAction(&a, nRequestID++);
		LOG((ab == 0) ? "......ͳɹ\n" : "......ʧܣ=[%d]\n", ab);
	}

	///ִ¼
	void ReqExecOrderInsert(int a)
	{
		CThostFtdcInputExecOrderField OrderInsert = { 0 };
		strcpy_s(OrderInsert.BrokerID, g_chBrokerID);
		strcpy_s(OrderInsert.InvestorID, g_chInvestorID);
		strcpy_s(OrderInsert.InstrumentID, g_chInstrumentID);
		strcpy_s(OrderInsert.ExchangeID, g_chExchangeID);
		//strcpy_s(OrderInsert.ExecOrderRef, "00001");
		strcpy_s(OrderInsert.UserID, g_chUserID);
		OrderInsert.Volume = 1;
		OrderInsert.RequestID = 1;
		OrderInsert.OffsetFlag = THOST_FTDC_OF_Close;//ƽ־
		OrderInsert.HedgeFlag = THOST_FTDC_HF_Speculation;//Ͷױ־
		if (a == 0) {
			OrderInsert.ActionType = THOST_FTDC_ACTP_Exec;//ִ
		}
		if (a == 1) {
			OrderInsert.ActionType = THOST_FTDC_ACTP_Abandon;//ִ
		}
		OrderInsert.PosiDirection = THOST_FTDC_PD_Long;//ֲֶշ
		OrderInsert.ReservePositionFlag = THOST_FTDC_EOPF_Reserve;//ȨȨǷڻͷı
		//OrderInsert.ReservePositionFlag = THOST_FTDC_EOPF_UnReserve;//ͷ
		OrderInsert.CloseFlag = THOST_FTDC_EOCF_NotToClose;//ȨȨɵͷǷԶƽ
		//OrderInsert.CloseFlag = THOST_FTDC_EOCF_AutoClose;//Զƽ
		//strcpy_s(OrderInsert.InvestUnitID, "");AccountID
		//strcpy_s(OrderInsert.AccountID, "");
		//strcpy_s(OrderInsert.CurrencyID, "CNY");
		//strcpy_s(OrderInsert.ClientID, "");
		int b = m_pUserApi->ReqExecOrderInsert(&OrderInsert, 1);
		LOG((b == 0) ? "ִ¼......ͳɹ\n" : "ִ¼......ʧܣ=[%d]\n", b);
	}

	///ִ
	void ReqExecOrderAction()
	{
		CThostFtdcInputExecOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		a.ExecOrderActionRef = 1;
		strcpy_s(a.ExecOrderRef, g_NewExecOrderRef);
		a.FrontID = g_NewFrontID;
		a.SessionID = g_NewSessionID;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.ExecOrderSysID, g_NewExecOrderSysID);
		a.ActionFlag = THOST_FTDC_AF_Delete;//ɾ
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		//strcpy_s(a.InvestUnitID, "");
		//strcpy_s(a.IPAddress, "");
		//strcpy_s(a.MacAddress, "");
		int b = m_pUserApi->ReqExecOrderAction(&a, 1);
		LOG((b == 0) ? "ִ......ͳɹ\n" : "ִ......ʧܣ=[%d]\n", b);
	}

	//
	void ReqBatchOrderAction()
	{
		CThostFtdcInputBatchOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//a.OrderActionRef = 1;
		a.FrontID = g_chFrontID;
		//a.SessionID = g_chSessionID;
		strcpy_s(a.ExchangeID,g_chExchangeID);
		strcpy_s(a.UserID,g_chUserID);
		int ab = m_pUserApi->ReqBatchOrderAction(&a, nRequestID++);
		LOG((ab == 0) ? "......ͳɹ\n" : "......ʧܣ=[%d]\n", ab);
	}

	///ѯ
	void ReqQryOrder()
	{
		action_number = 0;
		vector_OrderSysID.clear();
		vector_ExchangeID.clear();
		vector_InstrumentID.clear();
		CThostFtdcQryOrderField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.InstrumentID, g_chInstrumentID);
		//strcpy_s(a.ExchangeID, g_chExchangeID);
		int ab = m_pUserApi->ReqQryOrder(&a, nRequestID++);
		LOG((ab == 0) ? "ѯ......ͳɹ\n" : "ѯ......ʧܣ=[%d]\n", ab);
	}

	///¼
	void ReqOrderInsert_Condition(int select_num)
	{
		string limit_price;
		LOG("ָ۸(limitprice):\n");
		cin >> limit_price;

		string stop_price;
		LOG("봥۸(stopprice):\n");
		cin >> stop_price;

		CThostFtdcInputOrderField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.UserID, g_chUserID);
		a.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
		a.Direction = THOST_FTDC_D_Buy;//
		//a.CombOffsetFlag[0] = THOST_FTDC_OF_Open;
		a.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
		strcpy_s(a.CombOffsetFlag, "0");
		strcpy_s(a.CombHedgeFlag, "1");
		a.LimitPrice = atoi(limit_price.c_str());
		a.VolumeTotalOriginal = 1;
		a.TimeCondition = THOST_FTDC_TC_GFD;
		//a.VolumeCondition = THOST_FTDC_VC_AV;
		a.VolumeCondition = THOST_FTDC_VC_MV;
		a.MinVolume = 0;
		if (select_num == 1)
		{
			a.ContingentCondition = THOST_FTDC_CC_LastPriceGreaterThanStopPrice;
		}
		else if (select_num == 2)
		{
			a.ContingentCondition = THOST_FTDC_CC_LastPriceGreaterEqualStopPrice;
		}
		else if (select_num == 3)
		{
			a.ContingentCondition = THOST_FTDC_CC_LastPriceLesserThanStopPrice;
		}
		else if (select_num == 4)
		{
			a.ContingentCondition = THOST_FTDC_CC_LastPriceLesserEqualStopPrice;
		}
		else if (select_num == 5)
		{
			a.ContingentCondition = THOST_FTDC_CC_AskPriceGreaterThanStopPrice;
		}
		else if (select_num == 6)
		{
			a.ContingentCondition = THOST_FTDC_CC_AskPriceGreaterEqualStopPrice;
		}
		else if (select_num == 7)
		{
			a.ContingentCondition = THOST_FTDC_CC_AskPriceLesserThanStopPrice;
		}
		else if (select_num == 8)
		{
			a.ContingentCondition = THOST_FTDC_CC_AskPriceLesserEqualStopPrice;
		}
		else if (select_num == 9)
		{
			a.ContingentCondition = THOST_FTDC_CC_BidPriceGreaterThanStopPrice;
		}
		else if (select_num == 10)
		{
			a.ContingentCondition = THOST_FTDC_CC_BidPriceGreaterEqualStopPrice;
		}
		else if (select_num == 11)
		{
			a.ContingentCondition = THOST_FTDC_CC_BidPriceLesserThanStopPrice;
		}
		else if (select_num == 12)
		{
			a.ContingentCondition = THOST_FTDC_CC_BidPriceLesserEqualStopPrice;
		}
		a.StopPrice = atoi(stop_price.c_str());
		//itoa(a.StopPrice, const_cast<char *>(getConfig("config", "StopPrice").c_str()), 10);
		a.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
		a.IsAutoSuspend = 0;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int ab = m_pUserApi->ReqOrderInsert(&a, nRequestID++);
		LOG((ab == 0) ? "......ͳɹ\n" : "......ʧܣ=[%d]\n", ab);
	}

	///
	void ReqOrderAction_Condition()
	{
		CThostFtdcInputOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.UserID, g_chUserID);
		if (chioce_action == 0)
		{
			a.FrontID = g_chFrontID;
			a.SessionID = g_chSessionID;
			strcpy_s(a.OrderRef, g_chOrderRef);
		}
		if (chioce_action == 1)
		{
			strcpy_s(a.OrderSysID, g_chOrderSysID);
		}
		strcpy_s(a.ExchangeID, g_chExchangeID);
		a.ActionFlag = THOST_FTDC_AF_Delete;
		int ab = m_pUserApi->ReqOrderAction(&a, nRequestID++);
		LOG((ab == 0) ? "......ͳɹ\n" : "......ʧܣ=[%d]\n", ab);
	}

	//ѯı
	void ReqOrderAction_forqry(int action_num)
	{
		CThostFtdcInputOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.UserID, g_chUserID);

		strcpy_s(a.OrderSysID, vector_OrderSysID.at(action_num - 1).c_str());
		strcpy_s(a.ExchangeID, vector_ExchangeID.at(action_num - 1).c_str());
		strcpy_s(a.InstrumentID, vector_InstrumentID.at(action_num - 1).c_str());

		strcpy_s(a.OrderRef, vector_OrderRef.at(action_num - 1).c_str());
		a.FrontID = vector_FrontID.at(action_num - 1);
		a.SessionID = vector_SessionID.at(action_num - 1);

		a.ActionFlag = THOST_FTDC_AF_Delete;
		int ab = m_pUserApi->ReqOrderAction(&a, nRequestID++);
		LOG((ab == 0) ? "......ͳɹ\n" : "......ʧܣ=[%d]\n", ab);
	}

	///ѯɽ
	void ReqQryTrade()
	{
		CThostFtdcQryTradeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		string instr;
		instr.clear();
		LOG("Լ(Ϊ)\n");
		cin.ignore();
		getline(cin, instr);
		strcpy_s(a.InstrumentID, instr.c_str());

		string Exch;
		Exch.clear();
		LOG("뽻(Ϊ)\n");
		//cin.ignore();
		getline(cin, Exch);
		strcpy_s(a.ExchangeID, Exch.c_str());
		/*strcpy_s(a.TradeID, "");
		strcpy_s(a.TradeTimeStart, "");
		strcpy_s(a.TradeTimeEnd, "");*/
		int b = m_pUserApi->ReqQryTrade(&a, nRequestID++);
		LOG((b == 0) ? "ѯɽ......ͳɹ\n" : "ѯɽ......ʧܣ=[%d]\n", b);
	}

	///ѯԤ
	void ReqQryParkedOrder()
	{
		CThostFtdcQryParkedOrderField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int ab = m_pUserApi->ReqQryParkedOrder(&a, nRequestID++);
		LOG((ab == 0) ? "ѯԤ......ͳɹ\n" : "ѯԤ......ʧܣ=[%d]\n", ab);
	}

	//ѯԤ񳷵
	void ReqQryParkedOrderAction()
	{
		CThostFtdcQryParkedOrderActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int ab = m_pUserApi->ReqQryParkedOrderAction(&a, nRequestID++);
		LOG((ab == 0) ? "ѯԤ񳷵......ͳɹ\n" : "ѯԤ񳷵......ʧܣ=[%d]\n", ab);
	}

	//ѯʽ˻
	void ReqQryTradingAccount()
	{
		CThostFtdcQryTradingAccountField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.CurrencyID, "CNY");
		int ab = m_pUserApi->ReqQryTradingAccount(&a, nRequestID++);
		LOG((ab == 0) ? "ѯʽ˻......ͳɹ\n" : "ѯʽ˻......ʧܣ=[%d]\n", ab);
	}

	///ѯʽ˻Ӧ
	virtual void OnRspQryTradingAccount(CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspQryTradingAccount(pTradingAccount, pRspInfo, nRequestID, bIsLast);
	};

	//ѯͶֲ߳
	void ReqQryInvestorPosition()
	{
		CThostFtdcQryInvestorPositionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
	/*	string instr;
		instr.clear();
		cin.ignore();
		LOG("Լ(Ϊ)\n");
		getline(cin, instr);
		strcpy_s(a.InstrumentID, instr.c_str());*/
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		/*string exch;
		exch.clear();
		cin.ignore();
		LOG("뽻(Ϊ)\n");
		getline(cin, exch);
		strcpy_s(a.ExchangeID, exch.c_str());*/
		//strcpy_s(a.InstrumentID, "SPD");
		int b = m_pUserApi->ReqQryInvestorPosition(&a, nRequestID++);
		LOG((b == 0) ? "ѯͶֲ߳......ͳɹ\n" : "ѯͶֲ߳......ʧܣ=[%d]\n", b);
	}

	//ѯͶֲ߳ϸ
	void ReqQryInvestorPositionDetail()
	{
		CThostFtdcQryInvestorPositionDetailField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		/*string instr;
		instr.clear();
		cin.ignore();
		LOG("Լ(Ϊ)\n");
		getline(cin, instr);
		strcpy_s(a.InstrumentID, instr.c_str());*/

		strcpy_s(a.InstrumentID, g_chInstrumentID);
		/*string exch;
		exch.clear();
		cin.ignore();
		LOG("뽻(Ϊ)\n");
		getline(cin, exch);
		strcpy_s(a.ExchangeID, exch.c_str());*/

		//strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryInvestorPositionDetail(&a, nRequestID++);
		LOG((b == 0) ? "ѯͶֲ߳ϸ......ͳɹ\n" : "ѯͶֲ߳ϸ......ʧܣ=[%d]\n", b);
	}

	//ѯ֤
	void ReqQryExchangeMarginRate()
	{
		CThostFtdcQryExchangeMarginRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		a.HedgeFlag = THOST_FTDC_HF_Speculation;//Ͷ
		int b = m_pUserApi->ReqQryExchangeMarginRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯ֤......ͳɹ\n" : "ѯ֤......ʧܣ=[%d]\n", b);
	}

	//ѯԼ֤
	void ReqQryInstrumentMarginRate()
	{
		CThostFtdcQryInstrumentMarginRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.ExchangeID,g_chExchangeID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		a.HedgeFlag = THOST_FTDC_HF_Speculation;//Ͷ
		int b = m_pUserApi->ReqQryInstrumentMarginRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯԼ֤......ͳɹ\n" : "ѯԼ֤......ʧܣ=[%d]\n", b);
	}

	//ѯԼ
	void ReqQryInstrumentCommissionRate()
	{
		CThostFtdcQryInstrumentCommissionRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int b = m_pUserApi->ReqQryInstrumentCommissionRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯԼ......ͳɹ\n" : "ѯԼ......ʧܣ=[%d]\n", b);
	}

	//ѯ̺Լ
	void ReqQryMMInstrumentCommissionRate()
	{
		CThostFtdcQryMMInstrumentCommissionRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryMMInstrumentCommissionRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯ̺Լ......ͳɹ\n" : "ѯ̺Լ......ʧܣ=[%d]\n", b);
	}

	//ѯȨԼ
	void ReqQryMMOptionInstrCommRate()
	{
		CThostFtdcQryMMOptionInstrCommRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryMMOptionInstrCommRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯȨԼ......ͳɹ\n" : "ѯȨԼ......ʧܣ=[%d]\n", b);
	}

	//ѯ
	void ReqQryInstrumentOrderCommRate()
	{
		CThostFtdcQryInstrumentOrderCommRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryInstrumentOrderCommRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯ......ͳɹ\n" : "ѯ......ʧܣ=[%d]\n", b);
	}

	//ѯȨԼ
	void ReqQryOptionInstrCommRate()
	{
		CThostFtdcQryOptionInstrCommRateField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		string Inst;
		string Exch;
		string InvestUnit;
		LOG("Լ:(Ϊ)");
		cin >> Inst;
		LOG("뽻:(Ϊ)");
		cin >> Exch;
		LOG("ͶߵԪ:(Ϊ)");
		cin >> InvestUnit;
		strcpy_s(a.InstrumentID, Inst.c_str());
		strcpy_s(a.ExchangeID, Exch.c_str());
		strcpy_s(a.InvestUnitID, InvestUnit.c_str());
		int b = m_pUserApi->ReqQryOptionInstrCommRate(&a, nRequestID++);
		LOG((b == 0) ? "ѯȨԼ......ͳɹ\n" : "ѯȨԼ......ʧܣ=[%d]\n", b);
	}

	//ѯԼ
	void ReqQryInstrument()
	{
		CThostFtdcQryInstrumentField a = { 0 };
		strcpy_s(a.ExchangeID, g_chExchangeID);
		//strcpy_s(a.InstrumentID, g_chInstrumentID);
		//strcpy_s(a.ExchangeInstID,"");
		//strcpy_s(a.ProductID, "a");
		int b = m_pUserApi->ReqQryInstrument(&a, nRequestID++);
		LOG((b == 0) ? "ѯԼ......ͳɹ\n" : "ѯԼ......ʧܣ=[%d]\n", b);
	}

	///ѯԼӦ
	virtual void OnRspQryInstrument(CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspQryInstrument(pInstrument, pRspInfo, nRequestID, bIsLast);
		if (pInstrument)
		{
			md_InstrumentID.push_back(pInstrument->InstrumentID);
		}
		if (bIsLast)
		{
			SetEvent(xinhao);
		}
	}

	//ѯͶ߽
	void ReqQrySettlementInfo()
	{
		CThostFtdcQrySettlementInfoField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		string Traday;
		LOG("뽻ڻ߽·(:20180101,·201801):");
		cin >> Traday;
		strcpy_s(a.TradingDay, Traday.c_str());
		int b = m_pUserApi->ReqQrySettlementInfo(&a, nRequestID++);
		LOG((b == 0) ? "ѯͶ߽......ͳɹ\n" : "ѯͶ߽......ʧܣ=[%d]\n", b);
	}

	//ѯתˮ
	void ReqQryTransferSerial()
	{
		CThostFtdcQryTransferSerialField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.AccountID, g_chInvestorID);
	cir1:int bankid;
		LOG("ҪĲѯ\n");
		LOG("1.\n");
		LOG("2.ũҵ\n");
		LOG("3.й\n");
		LOG("5.ͨ\n");
		LOG("6.\n");
		LOG("7.ҵ\n");
		LOG("8.ַ\n");
		LOG("9.\n");
		LOG("10.\n");
		LOG("11.\n");
		LOG("12.\n");
		LOG("13.ƽ\n");
		LOG("14.ũ\n");
		LOG("15.չ\n");
		LOG("16.㷢\n");
		cin >> bankid;
		if (bankid == 1 | 2 | 3 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16)
		{
			//strcpy_s(a.BankID, itoa(bankid, a.BankID, 10));///д
			itoa(bankid, a.BankID, 10);
		}
		else
		{
			LOG("д롣\n");
			goto cir1;
		}
		int choos;
	curr:LOG("ִ\t1.CNY\t2.USD\n");
		cin >> choos;
		switch (choos)
		{
		case 1:
			strcpy_s(a.CurrencyID, "CNY");
			break;
		case 2:
			strcpy_s(a.CurrencyID, "USD");
			break;
		default:
			LOG("ȷ\n");
			_getch();
			goto curr;
		}
		int b = m_pUserApi->ReqQryTransferSerial(&a, nRequestID++);
		LOG((b == 0) ? "ѯתˮ......ͳɹ\n" : "ѯתˮ......ʧܣ=[%d]\n", b);
	}

	//ѯƷ
	void ReqQryProduct()
	{
		CThostFtdcQryProductField a = { 0 };
		strcpy_s(a.ProductID, "sc");
		a.ProductClass = THOST_FTDC_PC_Futures;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		m_pUserApi->ReqQryProduct(&a, nRequestID++);
	}

	//ѯת
	void ReqQryTransferBank()
	{
		CThostFtdcQryTransferBankField a = { 0 };
		strcpy_s(a.BankID,"3");
		int b = m_pUserApi->ReqQryTransferBank(&a, nRequestID++);
		LOG((b == 0) ? "ѯת......ͳɹ\n" : "ѯת......ʧܣ=[%d]\n", b);
	}

	//ѯ֪ͨ
	void ReqQryTradingNotice()
	{
		CThostFtdcQryTradingNoticeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		int b = m_pUserApi->ReqQryTradingNotice(&a, nRequestID++);
		LOG((b == 0) ? "ѯ֪ͨ......ͳɹ\n" : "ѯ֪ͨ......ʧܣ=[%d]\n", b);
	}

	//ѯͻ֪ͨ
	void ReqQryNotice()
	{
		CThostFtdcQryNoticeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		int b = m_pUserApi->ReqQryNotice(&a, nRequestID++);
		LOG((b == 0) ? "ѯͻ֪ͨ......ͳɹ\n" : "ѯͻ֪ͨ......ʧܣ=[%d]\n", b);
	}

	//ѯױ
	void ReqQryTradingCode()
	{
		CThostFtdcQryTradingCodeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		a.ClientIDType = THOST_FTDC_CIDT_Speculation;
		int b = m_pUserApi->ReqQryTradingCode(&a, nRequestID++);
		LOG((b == 0) ? "ѯױ......ͳɹ\n" : "ѯױ......ʧܣ=[%d]\n", b);
	}

	//ѯϢȷ
	void ReqQrySettlementInfoConfirm()
	{
		CThostFtdcQrySettlementInfoConfirmField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.AccountID, g_chInvestorID);
		strcpy_s(a.CurrencyID, "CNY");
		int b = m_pUserApi->ReqQrySettlementInfoConfirm(&a, nRequestID++);
		LOG((b == 0) ? "ѯϢȷ......ͳɹ\n" : "ѯϢȷ......ʧܣ=[%d]\n", b);
	}

	//ѯƷ
	void ReqQryProductGroup()
	{
		CThostFtdcQryProductGroupField a = { 0 };
		strcpy_s(a.ExchangeID, g_chExchangeID);
		//strcpy_s(a.ProductID, g_chInstrumentID);
		int b = m_pUserApi->ReqQryProductGroup(&a, nRequestID++);
		LOG((b == 0) ? "ѯƷ......ͳɹ\n" : "ѯƷ......ʧܣ=[%d]\n", b);
	}

	//ѯͶߵԪ
	void ReqQryInvestUnit()
	{
		CThostFtdcQryInvestUnitField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.InvestorID, g_chUserID);
		//strcpy_s(a.InvestUnitID, "");
		int b = m_pUserApi->ReqQryInvestUnit(&a, nRequestID++);
		LOG((b == 0) ? "ѯͶߵԪ......ͳɹ\n" : "ѯͶߵԪ......ʧܣ=[%d]\n", b);
	}

	//ѯ͹˾ײ
	void ReqQryBrokerTradingParams()
	{
		CThostFtdcQryBrokerTradingParamsField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.CurrencyID, "CNY");
		int b = m_pUserApi->ReqQryBrokerTradingParams(&a, nRequestID++);
		LOG((b == 0) ? "ѯ͹˾ײ......ͳɹ\n" : "ѯ͹˾ײ......ʧܣ=[%d]\n", b);
	}

	//ѯѯ
	void ReqQryForQuote()
	{
		CThostFtdcQryForQuoteField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.InsertTimeStart, "");
		strcpy_s(a.InsertTimeEnd, "");
		strcpy_s(a.InvestUnitID, "");
		int b = m_pUserApi->ReqQryForQuote(&a, nRequestID++);
		LOG((b == 0) ? "ѯѯ......ͳɹ\n" : "ѯѯ......ʧܣ=[%d]\n", b);
	}

	//ѯ
	void ReqQryQuote()
	{
		CThostFtdcQryQuoteField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.QuoteSysID, "");
		strcpy_s(a.InsertTimeStart, "");
		strcpy_s(a.InsertTimeEnd, "");
		strcpy_s(a.InvestUnitID, "");
		int b = m_pUserApi->ReqQryQuote(&a, nRequestID++);
		LOG((b == 0) ? "ѯѯ......ͳɹ\n" : "ѯѯ......ʧܣ=[%d]\n", b);
	}

	///ѯ¼
	void ReqForQuoteInsert()
	{
		CThostFtdcInputForQuoteField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		//strcpy_s(a.ForQuoteRef, "");
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		//strcpy_s(a.InvestUnitID, "");
		//strcpy_s(a.IPAddress, "");
		//strcpy_s(a.MacAddress, "");
		int b = m_pUserApi->ReqForQuoteInsert(&a, nRequestID++);
		LOG((b == 0) ? "ѯ¼......ͳɹ\n" : "ѯ¼......ʧܣ=[%d]\n", b);
	}

	///̱¼
	void ReqQuoteInsert()
	{
	choose:int choose_Flag;
		LOG("ȷϿƽ־\t1.\t2.ƽ\n");
		cin >> choose_Flag;

		if (choose_Flag != 1 && choose_Flag!=2)
		{
			LOG("ѡƽ־\n");
			_getch();
			choose_Flag = NULL;
			goto choose;
		}

		int price_bid;
		LOG("۸\n");
		cin >> price_bid;

		int price_ask;
		LOG("۸\n");
		cin >> price_ask;
		LOG("Ĭ1\n");
		string quoteref;
		LOG("quoterefţ\n");
		cin >> quoteref;
		string AskOrderRef;
		string BidOrderRef;
		LOG("AskOrderRef:\n");
		cin >> AskOrderRef;
		LOG("BidOrderRef:\n");
		cin >> BidOrderRef;
		_getch();
		CThostFtdcInputQuoteField t = { 0 };
		strcpy_s(t.BrokerID, g_chBrokerID);
		strcpy_s(t.InvestorID, g_chInvestorID);
		strcpy_s(t.InstrumentID, g_chInstrumentID);
		strcpy_s(t.ExchangeID, g_chExchangeID);
		
		strcpy_s(t.QuoteRef, quoteref.c_str());
		strcpy_s(t.UserID, g_chUserID);
		t.AskPrice = price_ask;
		t.BidPrice = price_bid;
		t.AskVolume = 1;
		t.BidVolume = 1;
		if (choose_Flag ==1)
		{
			t.AskOffsetFlag = THOST_FTDC_OF_Open;///ƽ־
			t.BidOffsetFlag = THOST_FTDC_OF_Open;///ƽ־
		}
		else if (choose_Flag ==2)
		{
			t.AskOffsetFlag = THOST_FTDC_OF_Close;///ƽ־
			t.BidOffsetFlag = THOST_FTDC_OF_Close;///ƽ־
		}
		t.AskHedgeFlag = THOST_FTDC_HF_Hedge;///Ͷױ־
		t.BidHedgeFlag = THOST_FTDC_HF_Hedge;///Ͷױ־

		strcpy_s(t.AskOrderRef, AskOrderRef.c_str());///
		strcpy_s(t.BidOrderRef, BidOrderRef.c_str());///򱨵
		//strcpy_s(t.ForQuoteSysID, "");///Ӧ۱
		//strcpy_s(t.InvestUnitID, "1");///ͶʵԪ
		timing tt;
		tt.start();//ʼ
		int a = m_pUserApi->ReqQuoteInsert(&t, 1);
		tt.end();
		LOG("ʱΪ = [%.8lf]ms\n", tt.gettime * 1000);
		LOG((a == 0) ? "̱¼......ͳɹ\n" : "̱¼......ʧܣ=[%d]\n", a);
	}

	///֪ͨ
	virtual void OnRtnQuote(CThostFtdcQuoteField *pQuote) 
	{
		if (pQuote && strcmp(pQuote->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			CTraderSpi::OnRtnQuote(pQuote);
			//SetEvent(g_hEvent);
		}
	}

	//۳
	void ReqQuoteAction()
	{
		CThostFtdcInputQuoteActionField t = { 0 };
		strcpy_s(t.BrokerID, g_chBrokerID);
		strcpy_s(t.InvestorID, "00404");
		//strcpy_s(t.UserID, g_chUserID);
		strcpy_s(t.ExchangeID, "SHFE");
		strcpy_s(t.QuoteRef, "           8");
		t.FrontID = 7;
		t.SessionID = 1879781311;
		t.ActionFlag = THOST_FTDC_AF_Delete;
		strcpy_s(t.InstrumentID, "cu1905C55000");
		int a = m_pUserApi->ReqQuoteAction(&t, 1);
		printf("m_pUserApi->ReqQuoteAction = [%d]", a);
	}

	//ѯ󱨵
	void ReqQryMaxOrderVolume()
	{
		CThostFtdcQryMaxOrderVolumeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		a.Direction = THOST_FTDC_D_Buy;
		a.OffsetFlag = THOST_FTDC_OF_Open;
		a.HedgeFlag = THOST_FTDC_HF_Speculation;
		a.MaxVolume = 1;
		strcpy_s(a.BrokerID, g_chBrokerID);
		int b = m_pUserApi->ReqQryMaxOrderVolume(&a, nRequestID++);
		LOG((b == 0) ? "ѯ󱨵......ͳɹ\n" : "ѯ󱨵......ʧܣ=[%d]\n", b);
	}

	//ѯû
	void ReqQueryCFMMCTradingAccountToken()
	{
		CThostFtdcQueryCFMMCTradingAccountTokenField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.InvestUnitID, "");
		int b = m_pUserApi->ReqQueryCFMMCTradingAccountToken(&a, nRequestID++);
		LOG((b == 0) ? "ѯû......ͳɹ\n" : "ѯû......ʧܣ=[%d]\n", b);
	}

	///֤û
	virtual void OnRtnCFMMCTradingAccountToken(CThostFtdcCFMMCTradingAccountTokenField* pCFMMCTradingAccountToken)
	{
		string web_address;
		web_address = "https://investorservice.cfmmc.com/loginByKey.do?companyID=";
		web_address.append(pCFMMCTradingAccountToken->ParticipantID);
		web_address.append("&userid=");
		web_address.append(pCFMMCTradingAccountToken->AccountID);
		web_address.append("&keyid=");
		int Key = pCFMMCTradingAccountToken->KeyID;
		std::stringstream kk;
		std::string k;
		kk << Key;
		kk >> k;
		web_address.append(k);
		web_address.append("&passwd=");
		web_address.append(pCFMMCTradingAccountToken->Token);
		LOG("webַΪ:%s\n",web_address.c_str());
	};


	///ر
	virtual void OnErrRtnOrderAction(CThostFtdcOrderActionField *pOrderAction, CThostFtdcRspInfoField *pRspInfo)
	{
		if (pOrderAction && strcmp(pOrderAction->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			CTraderSpi::OnErrRtnOrderAction(pOrderAction,pRspInfo);
			SetEvent(g_hEvent);
		}
	}

	///¼Ӧ
	virtual void OnRspOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		if (pInputOrder && strcmp(pInputOrder->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			CTraderSpi::OnRspOrderInsert(pInputOrder,pRspInfo,nRequestID,bIsLast);
		}
	}

	///¼ر
	virtual void OnErrRtnOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo)
	{
		if (pInputOrder && strcmp(pInputOrder->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			CTraderSpi::OnErrRtnOrderInsert(pInputOrder, pRspInfo);
			SetEvent(g_hEvent);
		}
	}

	///֪ͨ
	virtual void OnRtnOrder(CThostFtdcOrderField *pOrder)
	{
		if (pOrder && strcmp(pOrder->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			CTraderSpi::OnRtnOrder(pOrder);
			strcpy_s(g_chOrderSysID, pOrder->OrderSysID);
			g_chFrontID = pOrder->FrontID;
			g_chSessionID = pOrder->SessionID;
			strcpy_s(g_chOrderRef, pOrder->OrderRef);
			strcpy_s(g_chExchangeID, pOrder->ExchangeID);
			if (pOrder->OrderStatus == THOST_FTDC_OST_AllTraded)///ȫɽ
			{
				LOG("ȫɽ\n\n");
				//SetEvent(g_hEvent);
			}if (pOrder->OrderStatus == THOST_FTDC_OST_PartTradedQueueing)///ֳɽڶ
			{
				LOG("ֳɽڶ\n\n");
			}if (pOrder->OrderStatus == THOST_FTDC_OST_PartTradedNotQueueing)///ֳɽڶ
			{
				LOG("ֳɽڶ\n\n");
			}if (pOrder->OrderStatus == THOST_FTDC_OST_NoTradeQueueing)///δɽڶ
			{
				chioce_action = 0;
				LOG("δɽڶ\n\n");
				
			}if (pOrder->OrderStatus == THOST_FTDC_OST_NoTradeNotQueueing)///δɽڶ
			{
				LOG("δɽڶ\n\n");
			}if (pOrder->OrderStatus == THOST_FTDC_OST_Canceled)///
			{
				LOG("\n\n");
				//SetEvent(g_hEvent);
				//CSimpleHandler::ReqQryTradingAccount();
			}if (pOrder->OrderStatus == THOST_FTDC_OST_Unknown)///δ֪
			{
				LOG("δ֪\n\n");
				//CSimpleHandler::ReqQryTradingAccount();
			}if (pOrder->OrderStatus == THOST_FTDC_OST_NotTouched)///δ
			{
				chioce_action = 1;
				LOG("δ\n\n");
			}if (pOrder->OrderStatus == THOST_FTDC_OST_Touched)///Ѵ
			{
				LOG("Ѵ\n\n");
			}
		}
	}

	///ɾԤӦ
	virtual void OnRspRemoveParkedOrder(CThostFtdcRemoveParkedOrderField *pRemoveParkedOrder, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		if (pRemoveParkedOrder && strcmp(pRemoveParkedOrder->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			strcpy_s(g_chParkedOrderID1, pRemoveParkedOrder->ParkedOrderID);
			CTraderSpi::OnRspRemoveParkedOrder(pRemoveParkedOrder, pRspInfo, nRequestID, bIsLast);
			SetEvent(g_hEvent);
		}
	}

	///ɾԤ񳷵Ӧ
	virtual void OnRspRemoveParkedOrderAction(CThostFtdcRemoveParkedOrderActionField *pRemoveParkedOrderAction, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		if (pRemoveParkedOrderAction && strcmp(pRemoveParkedOrderAction->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			strcpy_s(g_chParkedOrderActionID1, pRemoveParkedOrderAction->ParkedOrderActionID);
			CTraderSpi::OnRspRemoveParkedOrderAction(pRemoveParkedOrderAction, pRspInfo, nRequestID, bIsLast);
			SetEvent(g_hEvent);
		}
	}

	///Ԥ¼Ӧ
	virtual void OnRspParkedOrderInsert(CThostFtdcParkedOrderField *pParkedOrder, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		if (pParkedOrder && strcmp(pParkedOrder->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			strcpy_s(g_chParkedOrderID1, pParkedOrder->ParkedOrderID);
			CTraderSpi::OnRspParkedOrderInsert(pParkedOrder, pRspInfo, nRequestID, bIsLast);
			SetEvent(g_hEvent);
		}
	}

	///Ԥ񳷵¼Ӧ
	virtual void OnRspParkedOrderAction(CThostFtdcParkedOrderActionField *pParkedOrderAction, CThostFtdcRspInfoField *pRspInfo,
		int nRequestID, bool bIsLast)
	{
		if (pParkedOrderAction && strcmp(pParkedOrderAction->InvestorID, g_chInvestorID) != 0)
		{
			return;
		}
		else
		{
			strcpy_s(g_chParkedOrderActionID1, pParkedOrderAction->ParkedOrderActionID);
			CTraderSpi::OnRspParkedOrderAction(pParkedOrderAction,pRspInfo,nRequestID,bIsLast);
			SetEvent(g_hEvent);
		}
	}

	///ѯԤ񳷵Ӧ
	virtual void OnRspQryParkedOrderAction(CThostFtdcParkedOrderActionField *pParkedOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspQryParkedOrderAction(pParkedOrderAction, pRspInfo, nRequestID, bIsLast);
	}

	///ѯԤӦ
	virtual void OnRspQryParkedOrder(CThostFtdcParkedOrderField *pParkedOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		CTraderSpi::OnRspQryParkedOrder(pParkedOrder,pRspInfo,nRequestID,bIsLast);
	}

	///ѯӦ
	virtual void OnRspQryOrder(CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		if (pOrder) {
			vector_OrderSysID.push_back(pOrder->OrderSysID);
			vector_ExchangeID.push_back(pOrder->ExchangeID);
			vector_InstrumentID.push_back(pOrder->InstrumentID);
			vector_OrderRef.push_back(pOrder->OrderRef);
			vector_FrontID.push_back(pOrder->FrontID);
			vector_SessionID.push_back(pOrder->SessionID);
		}
		CTraderSpi::OnRspQryOrder(pOrder,pRspInfo,nRequestID,bIsLast);
		action_number++;
		LOG("\nѯţ\"%d\"\n\n", action_number);
	}

	///ִ֪ͨ
	virtual void OnRtnExecOrder(CThostFtdcExecOrderField *pExecOrder) 
	{
		if (pExecOrder) {
			strcpy_s(g_NewExecOrderRef, pExecOrder->ExecOrderRef);
			strcpy_s(g_NewExecOrderSysID, pExecOrder->ExecOrderSysID);
			g_NewFrontID = pExecOrder->FrontID;
			g_NewSessionID = pExecOrder->SessionID;
		}
		CTraderSpi::OnRtnExecOrder(pExecOrder);
	}

	//ڻѯ
	void ReqQueryBankAccountMoneyByFuture()
	{
		CThostFtdcReqQueryAccountField a = { 0 };
		int b = m_pUserApi->ReqQueryBankAccountMoneyByFuture(&a, nRequestID++);
		LOG((b == 0) ? "ڻѯ......ͳɹ\n" : "ڻѯ......ʧܣ=[%d]\n", b);
	}

	//ڻʽתڻ
	void ReqFromBankToFutureByFuture()
	{
		int output_num;
		LOG("ת˽:");
		cin >> output_num;

		CThostFtdcReqTransferField a = { 0 };
		strcpy_s(a.TradeCode, "202001");///ҵ
	int bankid = 0;
		while (bankid != 1 & 2 & 3 & 5 & 6 & 7 & 8 & 9 & 10 & 11 & 12 & 13 & 14 & 15 & 16) {
			LOG("Ҫת˵\n");
			LOG("1.\n");
			LOG("2.ũҵ\n");
			LOG("3.й\n");
			LOG("5.ͨ\n");
			LOG("6.\n");
			LOG("7.ҵ\n");
			LOG("8.ַ\n");
			LOG("9.\n");
			LOG("10.\n");
			LOG("11.\n");
			LOG("12.\n");
			LOG("13.ƽ\n");
			LOG("14.ũ\n");
			LOG("15.չ\n");
			LOG("16.㷢\n");
			cin >> bankid;
			if (bankid == 1 | 2 | 3 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16)
			{
				//strcpy_s(a.BankID, itoa(bankid, a.BankID, 10));///д
				itoa(bankid, a.BankID, 10);
			}
			else
			{
				LOG("д롣\n");
				_getch();
			}
		}
		
		
		strcpy_s(a.BankBranchID, "0000");///̴
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.TradeDate, "20170829");///
		//strcpy_s(a.TradeTime, "09:00:00");
		//strcpy_s(a.BankSerial, "6889");///ˮ
		//strcpy_s(a.TradingDay, "20170829");///ϵͳ 
		//a.PlateSerial = 5;///ƽ̨Ϣˮ
		a.LastFragment = THOST_FTDC_LF_Yes;///Ƭ־ '0'=Ƭ
		a.SessionID = SessionID;
		//strcpy_s(a.CustomerName, "");///ͻ
		a.IdCardType = THOST_FTDC_ICT_IDCard;///֤
		a.CustType = THOST_FTDC_CUSTT_Person;///ͻ
		//strcpy_s(a.IdentifiedCardNo, "310115198704111914");///֤
		/*strcpy_s(a.BankAccount, "123456789");
		strcpy_s(a.BankPassWord, "123456");///*/
		//strcpy_s(a.BankAccount, "621485212110224187");
		//strcpy_s(a.BankPassWord, "092812");///--Ҫп
		strcpy_s(a.AccountID, g_chInvestorID);///Ͷʺ
		//strcpy_s(a.Password, "092812");///ڻ--ʽ
		strcpy_s(a.Password, "123456");///ڻ--ʽ
		//a.InstallID = 1;///װ
		//a.FutureSerial = 0;///ڻ˾ˮ
		a.VerifyCertNoFlag = THOST_FTDC_YNI_No;///֤ͻ֤־
		strcpy_s(a.CurrencyID, "CNY");///ִ
		a.TradeAmount = output_num;///תʽ
		//a.FutureFetchAmount = 0;///ڻȡ
		//a.CustFee = 0;///Ӧտͻ
		//a.BrokerFee = 0;///Ӧڻ˾
		a.SecuPwdFlag = THOST_FTDC_BPWDF_BlankCheck;///ڻʽ˶Ա־
		//a.RequestID = 0;///
		//a.TID = 0;///ID
		int b = m_pUserApi->ReqFromBankToFutureByFuture(&a, 1);
		LOG((b == 0) ? "ڻʽתڻ......ͳɹ\n" : "ڻʽתڻ......ʧܣ=[%d]\n", b);
	}

	//ڻڻʽת
	void ReqFromFutureToBankByFuture()
	{
		int output_num;
		LOG("ת˽:");
		cin >> output_num;

		CThostFtdcReqTransferField a = { 0 };
		strcpy_s(a.TradeCode, "202002");///ҵ
		bankid_new:int bankid = 0;
		LOG("Ҫת˵\n");
		LOG("1.\n");
		LOG("2.ũҵ\n");
		LOG("3.й\n");
		LOG("5.ͨ\n");
		LOG("6.\n");
		LOG("7.ҵ\n");
		LOG("8.ַ\n");
		LOG("9.\n");
		LOG("10.\n");
		LOG("11.\n");
		LOG("12.\n");
		LOG("13.ƽ\n");
		LOG("14.ũ\n");
		LOG("15.չ\n");
		LOG("16.㷢\n");
		cin >> bankid;
		if (bankid == 1 | 2 | 3 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16)
		{
			//strcpy_s(a.BankID, itoa(bankid, a.BankID, 10));///д
			itoa(bankid, a.BankID, 10);
		}
		else {
			LOG("ȷı\n");
			_getch();
			goto bankid_new;
		}
		strcpy_s(a.BankBranchID, "0000");///̴
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.BankBranchID, "0000");///з֧
		//strcpy_s(a.TradeDate, "20170829");///
		//strcpy_s(a.TradeTime, "09:00:00");
		//strcpy_s(a.BankSerial, "");///ˮ
		//strcpy_s(a.TradingDay, "20170829");///ϵͳ 
		//a.PlateSerial= 0;///ƽ̨Ϣˮ
		a.LastFragment = THOST_FTDC_LF_Yes;///Ƭ־ '0'=Ƭ
		a.SessionID = SessionID;
		//strcpy_s(a.CustomerName, "");///ͻ
		a.IdCardType = THOST_FTDC_ICT_IDCard;///֤
		strcpy_s(a.IdentifiedCardNo, "310115198704111914");///֤
		strcpy_s(a.BankAccount, "123456789");///ʺ
		//strcpy_s(a.BankPassWord, "123456");///
		strcpy_s(a.AccountID, g_chInvestorID);///Ͷʺ
		strcpy_s(a.Password, "123456");///ڻ
		a.InstallID = 1;///װ
		a.CustType = THOST_FTDC_CUSTT_Person;
		//a.FutureSerial = 0;///ڻ˾ˮ
		a.VerifyCertNoFlag = THOST_FTDC_YNI_No;///֤ͻ֤־
		strcpy_s(a.CurrencyID, "CNY");///ִ
		a.TradeAmount = output_num;///תʽ
		a.FutureFetchAmount = 0;///ڻȡ
		a.CustFee = 0;///Ӧտͻ
		a.BrokerFee = 0;///Ӧڻ˾
		//a.SecuPwdFlag = THOST_FTDC_BPWDF_BlankCheck;///ڻʽ˶Ա־
		a.RequestID = 0;///
		a.TID = 0;///ID
		int b = m_pUserApi->ReqFromFutureToBankByFuture(&a, 1);
		LOG((b == 0) ? "ڻڻʽת......ͳɹ\n" : "ڻڻʽת......ʧܣ=[%d]\n", b);
	}

	//ȨԶԳ¼
	void ReqOptionSelfCloseInsert()
	{
		CThostFtdcInputOptionSelfCloseField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.OptionSelfCloseRef, "1");
		strcpy_s(a.UserID, g_chUserID);
		a.Volume = 1;
		
		int choose_1 = 0;
		while (choose_1 != 1 && choose_1 != 2 && choose_1 != 3 && choose_1 != 4) {
			LOG("ѡͶױ־\n1.Ͷ\t2.\t3.ױ\t4.\n");
			cin >> choose_1;
			if (choose_1 == 1) { a.HedgeFlag = THOST_FTDC_HF_Speculation; }
			else if (choose_1 == 2) { a.HedgeFlag = THOST_FTDC_HF_Arbitrage; }
			else if (choose_1 == 3) { a.HedgeFlag = THOST_FTDC_HF_Hedge; }
			else if (choose_1 == 4) { a.HedgeFlag = THOST_FTDC_HF_MarketMaker; }
			else {
				LOG("ѡѡ\n");
				_getch();
			}
		}
		
		int choose_2 = 0;
		while (choose_2 != 1 && choose_2 != 2 && choose_2 != 3) {
			LOG("ѡȨȨͷǷԶԳ־\n1.ԶԳȨλ\t2.Ȩλ\t3.ԶԳԼڻλ\n");
			cin >> choose_2;
			if (choose_2 == 1) { a.OptSelfCloseFlag = THOST_FTDC_OSCF_CloseSelfOptionPosition; }
			else if (choose_2 == 2) { a.OptSelfCloseFlag = THOST_FTDC_OSCF_ReserveOptionPosition; }
			else if (choose_2 == 3) { a.OptSelfCloseFlag = THOST_FTDC_OSCF_SellCloseSelfFuturePosition; }
			else {
				LOG("ѡѡ\n");
				_getch();
				continue;
			}
		}

		strcpy_s(a.ExchangeID, g_chExchangeID);
		string accountid_new;
		LOG("ʽ˺:\n");
		cin >> accountid_new;
		strcpy_s(a.AccountID, accountid_new.c_str());
		strcpy_s(a.CurrencyID, "CNY");
		int b = m_pUserApi->ReqOptionSelfCloseInsert(&a, 1);
		LOG((b == 0) ? "ȨԶԳ¼......ͳɹ\n" : "ȨԶԳ¼......ʧܣ=[%d]\n", b);
	}

	///ȨԶԳ֪ͨ
	virtual void OnRtnOptionSelfClose(CThostFtdcOptionSelfCloseField *pOptionSelfClose)
	{
		if (pOptionSelfClose) {
			g_chFrontID = pOptionSelfClose->FrontID;
			g_chSessionID = pOptionSelfClose->SessionID;
			strcpy_s(g_chOptionSelfCloseSysID, pOptionSelfClose->OptionSelfCloseSysID);//ȨԶԳ
			strcpy_s(g_chOptionSelfCloseRef, pOptionSelfClose->OptionSelfCloseRef);//ȨԶԳ
		}
		CTraderSpi::OnRtnOptionSelfClose(pOptionSelfClose);
	}

	//ȨԶԳ
	void ReqOptionSelfCloseAction()
	{
		CThostFtdcInputOptionSelfCloseActionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		//strcpy_s(a.OptionSelfCloseSysID, g_chOptionSelfCloseSysID);//ȨԶԳ
		strcpy_s(a.OptionSelfCloseRef, g_chOptionSelfCloseRef);//ȨԶԳ
		//a.FrontID = g_chFrontID;
		//a.SessionID = g_chSessionID;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		a.ActionFlag = THOST_FTDC_AF_Delete;
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		int b = m_pUserApi->ReqOptionSelfCloseAction(&a, 1);
		LOG((b == 0) ? "ȨԶԳ......ͳɹ\n" : "ȨԶԳ......ʧܣ=[%d]\n", b);
	}

	//ѯȨԶԳ
	void ReqQryOptionSelfClose()
	{
		CThostFtdcQryOptionSelfCloseField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		int b = m_pUserApi->ReqQryOptionSelfClose(&a, 1);
		LOG((b == 0) ? "ѯȨԶԳ......ͳɹ\n" : "ѯȨԶԳ......ʧܣ=[%d]\n", b);
	}

	///ѯȨԶԳӦ
	virtual void OnRspQryOptionSelfClose(CThostFtdcOptionSelfCloseField *pOptionSelfClose, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
	{
		if (pOptionSelfClose) {
			g_chFrontID = pOptionSelfClose->FrontID;
			g_chSessionID = pOptionSelfClose->SessionID;
			strcpy_s(g_chOptionSelfCloseSysID, pOptionSelfClose->OptionSelfCloseSysID);//ȨԶԳ
			strcpy_s(g_chOptionSelfCloseRef, pOptionSelfClose->OptionSelfCloseRef);//ȨԶԳ
		}
		CTraderSpi::OnRspQryOptionSelfClose(pOptionSelfClose, pRspInfo, nRequestID, bIsLast);
	}

	///ѯִ
	void ReqQryExecOrder()
	{
		CThostFtdcQryExecOrderField a = { 0 }; 
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID, g_chInstrumentID);
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.ExecOrderSysID, "");
		strcpy_s(a.InsertTimeStart, "");
		strcpy_s(a.InsertTimeEnd, "");
		int b = m_pUserApi->ReqQryExecOrder(&a, 1);
		LOG((b == 0) ? "ִѯ......ͳɹ\n" : "ִѯ......ʧܣ=[%d]\n", b);
	}

	///ѯʽ˻
	void ReqQrySecAgentTradingAccount()
	{
		CThostFtdcQryTradingAccountField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.CurrencyID, "CNY");
		a.BizType = THOST_FTDC_BZTP_Future;
		strcpy_s(a.AccountID, g_chInvestorID);
		int b = m_pUserApi->ReqQrySecAgentTradingAccount(&a, 1);
		LOG((b == 0) ? "ѯʽ˻......ͳɹ\n" : "ѯʽ˻......ʧܣ=[%d]\n", b);
	}

	///ѯʽУģʽ
	void ReqQrySecAgentCheckMode()
	{
		CThostFtdcQrySecAgentCheckModeField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		int b = m_pUserApi->ReqQrySecAgentCheckMode(&a, 1);
		LOG((b == 0) ? "ѯʽУģʽ......ͳɹ\n" : "ѯʽУģʽ......ʧܣ=[%d]\n", b);
	}

	///עûնϢм̷ģʽ
	///Ҫն֤ɹû¼ǰøýӿ
	void RegisterUserSystemInfo()
	{
		char pSystemInfo[344];
		int len;
		CTP_GetSystemInfo(pSystemInfo, len);

		CThostFtdcUserSystemInfoField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		memcpy(a.ClientSystemInfo, pSystemInfo, len);
		a.ClientSystemInfoLen = len;

		/*string ip;
		ip.clear();
		cin.ignore();
		LOG("ipַ(Ϊ)\n");
		getline(cin, ip);
		strcpy_s(a.ClientPublicIP, ip.c_str());*/
		strcpy_s(a.ClientPublicIP, "192.168.0.1");//ipַ

		//int Port;
		//Port = 0;
		//cin.ignore();
		//LOG("˿ں\n");
		//cin >> Port;
		//a.ClientIPPort = Port;//˿ں
		a.ClientIPPort = 51305;//˿ں

		/*string LoginTime;
		LoginTime.clear();
		cin.ignore();
		LOG("¼ʱ(Ϊ)\n");
		getline(cin, LoginTime);
		strcpy_s(a.ClientPublicIP, LoginTime.c_str());*/
		//strcpy_s(a.ClientLoginTime, "20190121");
		strcpy_s(a.ClientAppID, g_chAppID);
		int b = m_pUserApi->RegisterUserSystemInfo(&a);
		LOG((b == 0) ? "עûնϢ......ͳɹ\n" : "עûնϢ......ʧܣ=[%d]\n", b);
	}

	///ϱûնϢм̷Ա¼ģʽ
	///Ա¼󣬿ԶεøýӿϱͻϢ
	void SubmitUserSystemInfo()
	{
		char pSystemInfo[344];
		int len;
		CTP_GetSystemInfo(pSystemInfo, len);

		CThostFtdcUserSystemInfoField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		memcpy(a.ClientSystemInfo, pSystemInfo, len);
		a.ClientSystemInfoLen = len;

		/*string ip;
		ip.clear();
		cin.ignore();
		LOG("ipַ(Ϊ)\n");
		getline(cin, ip);
		strcpy_s(a.ClientPublicIP, ip.c_str());*/
		strcpy_s(a.ClientPublicIP, "192.168.0.1");//ipַ

		//int Port;
		//Port = 0;
		//cin.ignore();
		//LOG("˿ں\n");
		//cin >> Port;
		//a.ClientIPPort = Port;//˿ں
		a.ClientIPPort = 51305;//˿ں

		/*string LoginTime;
		LoginTime.clear();
		cin.ignore();
		LOG("¼ʱ(Ϊ)\n");
		getline(cin, LoginTime);
		strcpy_s(a.ClientPublicIP, LoginTime.c_str());*/
		strcpy_s(a.ClientLoginTime, "20190121");
		strcpy_s(a.ClientAppID, g_chAppID);
		int b = m_pUserApi->SubmitUserSystemInfo(&a);
		LOG((b == 0) ? "עûնϢ......ͳɹ\n" : "עûնϢ......ʧܣ=[%d]\n", b);
	}

	//void test()
	//{
	//	char pSystemInfo[344];
	//	int len;
	//	CTP_GetSystemInfoUnAesEncode(pSystemInfo,len);
	//	//printf("a = %d\n",a);
	//	printf("pSystemInfo = %s\nlen = %d\n",pSystemInfo,len);
	//}

	///ѯûǰֵ֧֤ģʽ
	void ReqUserAuthMethod()
	{
		CThostFtdcReqUserAuthMethodField a = { 0 };
		strcpy_s(a.TradingDay, "20190308");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		int b = m_pUserApi->ReqUserAuthMethod(&a, nRequestID++);
		LOG((b == 0) ? "ѯûǰֵ֧֤ģʽ......ͳɹ\n" : "ѯûǰֵ֧֤ģʽ......ʧܣ=[%d]\n", b);
	}

	//ѯԱ̻
	void ReqQryTraderOffer()
	{
		CThostFtdcQryTraderOfferField a = {0};
		strcpy_s(a.ExchangeID,"SHFE");
		//strcpy_s(a.ParticipantID, "SHFE");
		//strcpy_s(a.TraderID, "SHFE");
		int b = m_pUserApi->ReqQryTraderOffer(&a, nRequestID++);
		LOG((b == 0) ? "ѯԱ̻......ͳɹ\n" : "ѯԱ̻......ʧܣ=[%d]\n", b);
	}

	///ûȡͼ֤
	void ReqGenUserCaptcha()
	{
		CThostFtdcReqGenUserCaptchaField a = { 0 };
		strcpy_s(a.TradingDay, "");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		int b = m_pUserApi->ReqGenUserCaptcha(&a, nRequestID++);
		LOG((b == 0) ? "ûȡͼ֤......ͳɹ\n" : "ûȡͼ֤......ʧܣ=[%d]\n", b);
	}

	///ûȡ֤
	void ReqGenUserText()
	{
		CThostFtdcReqGenUserTextField a = { 0 };
		strcpy_s(a.TradingDay, "");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		int b = m_pUserApi->ReqGenUserText(&a, nRequestID++);
		LOG((b == 0) ? "ûȡ֤......ͳɹ\n" : "ûȡ֤......ʧܣ=[%d]\n", b);
	}

	///ûͼƬ֤ĵ½
	void ReqUserLoginWithCaptcha()
	{
		CThostFtdcReqUserLoginWithCaptchaField a = { 0 };
		strcpy_s(a.TradingDay, "");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.Password, g_chPassword);
		strcpy_s(a.UserProductInfo, "");
		strcpy_s(a.InterfaceProductInfo, "");
		strcpy_s(a.ProtocolInfo, "");//ЭϢ
		strcpy_s(a.MacAddress, "");//Macַ
		strcpy_s(a.ClientIPAddress, "");//նIPַ
		strcpy_s(a.LoginRemark, "");//¼
		strcpy_s(a.Captcha, "");//ͼ֤
		a.ClientIPPort = 10203;
		int b = m_pUserApi->ReqUserLoginWithCaptcha(&a, nRequestID++);
		LOG((b == 0) ? "ûͼƬ֤ĵ½......ͳɹ\n" : "ûͼƬ֤ĵ½......ʧܣ=[%d]\n", b);
	}

	///ûж֤ĵ½
	void ReqUserLoginWithText()
	{
		CThostFtdcReqUserLoginWithTextField a = { 0 };
		strcpy_s(a.TradingDay, "");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.Password, g_chPassword);
		strcpy_s(a.UserProductInfo, "");
		strcpy_s(a.InterfaceProductInfo, "");
		strcpy_s(a.MacAddress, "");
		strcpy_s(a.ClientIPAddress, "");
		strcpy_s(a.LoginRemark, "");
		strcpy_s(a.Text, "");
		a.ClientIPPort = 10000;
		int b = m_pUserApi->ReqUserLoginWithText(&a, nRequestID++);
		LOG((b == 0) ? "ûж֤ĵ½......ͳɹ\n" : 
			"ûж֤ĵ½......ʧܣ=[%d]\n", b);
	}

	///ûж̬ĵ½
	void ReqUserLoginWithOTP()
	{
		CThostFtdcReqUserLoginWithOTPField a = { 0 };
		strcpy_s(a.TradingDay, "");
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.UserID, g_chUserID);
		strcpy_s(a.Password, g_chPassword);
		strcpy_s(a.UserProductInfo, "");
		strcpy_s(a.InterfaceProductInfo, "");
		strcpy_s(a.MacAddress, "");
		strcpy_s(a.ClientIPAddress, "");
		strcpy_s(a.LoginRemark, "");
		strcpy_s(a.OTPPassword, "");
		a.ClientIPPort = 10000;
		int b = m_pUserApi->ReqUserLoginWithOTP(&a, nRequestID++);
		LOG((b == 0) ? "ûж̬ĵ½......ͳɹ\n" : "ûж̬ĵ½......ʧܣ=[%d]\n", b);
	}

	///ѯϢ
	void ReqQrySecAgentTradeInfo()
	{
		CThostFtdcQrySecAgentTradeInfoField a = { 0 };
		strcpy_s(a.BrokerID, "");
		strcpy_s(a.BrokerSecAgentID, "");
		int b = m_pUserApi->ReqQrySecAgentTradeInfo(&a, nRequestID++);
		LOG((b == 0) ? "ѯϢ......ͳɹ\n" : "ѯϢ......ʧܣ=[%d]\n", b);
	}

	//ѯԼ
	void ReqQryClassifiedInstrument()
	{
		CThostFtdcQryClassifiedInstrumentField a = { 0 };
		//strcpy_s(a.InstrumentID,"");
		//strcpy_s(a.ExchangeID,"INE");
		//strcpy_s(a.ExchangeInstID,"");
		//strcpy_s(a.ProductID,"nr");
		a.TradingType = THOST_FTDC_TD_TRADE;
		a.ClassType = THOST_FTDC_INS_FUTURE;
		int b = m_pUserApi->ReqQryClassifiedInstrument(&a, nRequestID++);
		LOG((b == 0) ? "ѯԼ......ͳɹ\n" : "ѯԼ......ʧܣ=[%d]\n", b);
	}

	//Żݱ
	void ReqQryCombPromotionParam()
	{
		CThostFtdcQryCombPromotionParamField a = { 0 };
		strcpy_s(a.ExchangeID,"DCE");
		strcpy_s(a.InstrumentID,"SPD m_o&m_o");
		int b = m_pUserApi->ReqQryCombPromotionParam(&a, nRequestID++);
		LOG((b == 0) ? "Żݱ......ͳɹ\n" : "Żݱ......ʧܣ=[%d]\n", b);
	}

	//ѯͶƷ/Ʒֱ֤
	void ReqQryInvestorProductGroupMargin()
	{
		CThostFtdcQryInvestorProductGroupMarginField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		a.HedgeFlag = THOST_FTDC_HF_Speculation;
		strcpy_s(a.ExchangeID, g_chExchangeID);
		strcpy_s(a.ProductGroupID, g_chInstrumentID);
		strcpy_s(a.reserve1,g_chInstrumentID);
		int b = m_pUserApi->ReqQryInvestorProductGroupMargin(&a, nRequestID++);
		LOG((b == 0) ? "ѯͶƷ/Ʒֱ֤......ͳɹ\n" : "ѯͶƷ/Ʒֱ֤......ʧܣ=[%d]\n", b);
	}

	//ѯ֤
	void ReqQryExchangeMarginRateAdjust()
	{
		CThostFtdcQryExchangeMarginRateAdjustField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		//strcpy_s(a.reserve1, "");
		a.HedgeFlag = THOST_FTDC_HF_Speculation;
		strcpy_s(a.InstrumentID,g_chInstrumentID);
		int b = m_pUserApi->ReqQryExchangeMarginRateAdjust(&a, nRequestID++);
		LOG((b == 0) ? "ѯ֤......ͳɹ\n" : "ѯ֤......ʧܣ=[%d]\n", b);
	}

	///Ͷ߷սֲֲѯ
	void ReqQryRiskSettleInvstPosition()
	{
		CThostFtdcQryRiskSettleInvstPositionField a = { 0 };
		strcpy_s(a.BrokerID, g_chBrokerID);
		strcpy_s(a.InvestorID, g_chInvestorID);
		strcpy_s(a.InstrumentID,g_chInstrumentID);
		int b = m_pUserApi->ReqQryRiskSettleInvstPosition(&a, nRequestID++);
		LOG((b == 0) ? "Ͷ߷սֲֲѯ......ͳɹ\n" : "Ͷ߷սֲֲѯ......ʧܣ=[%d]\n", b);
	}

	///սƷѯ
	void ReqQryRiskSettleProductStatus()
	{
		CThostFtdcQryRiskSettleProductStatusField a = { 0 };
		strcpy_s(a.ProductID, g_chBrokerID);
		int b = m_pUserApi->ReqQryRiskSettleProductStatus(&a, nRequestID++);
		LOG((b == 0) ? "սƷѯ......ͳɹ\n" : "սƷѯ......ʧܣ=[%d]\n", b);
	}


private:
	CThostFtdcTraderApi *m_pUserApi;
};
